# MONSDA

[![Documentation Status](https://readthedocs.org/projects/monsda/badge/?version=latest)](https://monsda.readthedocs.io/en/latest/?badge=latest) [![install with bioconda](https://img.shields.io/badge/install%20with-bioconda-brightgreen.svg?style=flat)](http://bioconda.github.io/recipes/monsda/README.html) [![PyPI Latest Release](https://img.shields.io/pypi/v/MONSDA.svg)](https://pypi.org/project/MONSDA/) [![PRs](https://img.shields.io/badge/PRs-welcome-blue)](https://github.com/jfallmann/MONSDA/pulls) [![DOI](https://zenodo.org/badge/185782433.svg)](https://zenodo.org/badge/latestdoi/185782433)

Welcome to MONSDA, Modular Organizer of Nextflow and Snakemake driven hts Data Analysis

Automating HTS analysis from data download, preprocessing and mapping to
postprocessing/analysis and track generation centered on a single config file.
MONSDA can create ```Snakemake``` and ```Nextflow``` workflows based on user defined configuration.
These workflows can either be saved to disk for manual inspection and execution or automatically executed.

For details on ```Snakemake``` and ```Nextflow``` and their features please refer to the corresponding [Snakemake](https://Snakemake.readthedocs.io/en/stable/tutorial/tutorial.html)  or [Nextflow](https://www.Nextflow.io/docs/latest/index.html) documentation.

In general it is necessary to write a configuration file containing information on paths, files to process and settings beyond default for mapping tools and others.
The template on which analysis is based can be found in the ```config``` directory.

For MONSDA to be as FAIR as possible, one needs to use ```conda``` or the faster drop-in replacement ```mamba``` or ```conda-libmamba-solver``` which is a new (experimental) solver for the conda package manager and speeds up conda without the need to install mamba. For details on either please refer to the corresponding [conda](https://docs.conda.io/en/latest/) or [mamba](https://mamba.readthedocs.io/en/latest/) or [conda-libmamba-solver](https://github.com/conda-incubator/conda-libmamba-solver) manual.

This workflow collection makes heavy use of ```conda``` and especially the [bioconda](https://bioconda.github.io) channel.

## Install MONSDA via ```conda``` or ```pip```

To install via ```conda/mamba``` simply run

```
conda install -c bioconda -c conda-forge monsda
```

To install via ```pip``` you first need to create the ```MONSDA``` environment as found in the ```envs``` directory of this repository like so:

```
conda env create -n monsda -f MONSDA/envs/monsda.yaml
```

The ```envs``` directory holds all the environments needed to run the pipelines in the ```workflows``` directory, these will be installed automatically alongside ```MONSDA```.

For that activate the ```monsda``` environment and run ```pip```

```
conda activate monsda
pip install MONSDA
```

More information can be found in the official [documentation](https://monsda.readthedocs.io/en/latest/?badge=latest)


## How does it work

This repository hosts the executable ```MONSDA.py``` which acts a wrapper around ```Snakemake``` and the ```config.json``` file.
The ```config.json``` holds all the information that is needed to run the jobs and will be parsed by ```MONSDA.py``` and split into sub-configs that can later be found in the directory ```SubSnakes``` or ```SubFlows``` respectively.

To successfully run an analysis pipeline, a few steps have to be followed:
  * Directory structure: The structure for the directories is dictated by the condition-tree in the config file
  * Config file: This is the central part of the analysis. Depending on this file ```MONSDA.py``` will determine processing steps and generate according config and ```Snakemake/Nextflow``` workflow files to run each subworkflow until all processing steps are done.

## Run the pipeline

Run

```
monsda
```
to see the help and available options that will be passed through to ```Snakemake``` or ```Nextflow```.

and 

```
monsda_configure
```

To spin up the configurator that guides you through the creation of config.json files.

Once a config.json is available you can start a ```Snakemake``` run with

```
monsda -j ${THREADS} --configfile ${CONFIG}.json --directory ${PWD} --conda-frontend mamba --conda-prefix ${PATH_TO_conda_envs}
```
and add additional arguments for ```Snakemake``` as you see fit.


For a ```Nextflow``` run use
```
monsda --nextflow -j ${THREADS} --configfile ${CONFIG}.json --directory ${PWD}
```
and add additional arguments for ```Nextflow``` as you see fit.


### Run on workload manager

####SLURM

You can either use the slurm profile adapted from [Snakemake-Profiles](https://github.com/Snakemake-Profiles/slurm) that can be found in the ```profile_Snakemake``` directory, or go through the process of manually creating one, either using the cookiecutter example in the ```Snakemake-Profiles``` repository or on your own. 
For ```Nextflow``` a minimalist's example profile can be found under ```profile_Nextflow```.

Then run
```
monsda -j ${THREADS} --configfile ${CONFIG}.json --directory ${PWD} --conda-frontend mamba --profile ${SLURMPROFILE} --conda-prefix ${PATH_TO_conda_envs}
```
or
```
export NXF_EXECUTOR=slurm; monsda --nextflow -j ${THREADS} --configfile ${CONFIG}.json --directory ${PWD}
```
respectively.


For other workload managers please refer to the documentation of ```Snakemake``` and ```Nextflow```.


## Contribute
If you like this project, are missing features, want to contribute or
file bugs please leave an issue or contact me directly.

To contribute new tools feel free to adopt existing ones,
there should be a number of examples available that cover
implementation details for almost all sorts of tools. If you need to
add new python/groovy functions for processing of options or
parameters add them to the corresponding file in the ```MONSDA``` directory.
New environments go into the envs directory, new subworkflows into the
workflows directory. Do not forget to also extend the template.json
and add some documentation.

PRs always welcome.

suppressPackageStartupMessages({
    require(BiocParallel)
    library(tximport)
    library(GenomicFeatures)
    library(DRIMSeq)
    library(DEXSeq)
    library(rtracklayer)
})

options(echo = TRUE)

### ARGS
args <- commandArgs(trailingOnly = TRUE)
argsLen <- length(args)
anname <- args[1]
gtf <- args[2]
outdir <- args[3]
cmp <- args[4]
combi <- args[5]
cores <- as.integer(args[6])
filter <- if (argsLen > 6) args[7] else "min_samps_feature_expr = 1, min_feature_expr = .1, min_samps_gene_expr = 1, min_gene_expr = 1"
print(args)


## FUNCS
libp <- paste0(gsub("/bin/conda", "/envs/monsda", Sys.getenv("CONDA_EXE")), "/share/MONSDA/scripts/lib/_lib.R")
source(libp)

### SCRIPT
# load gtf
gtf.rtl <- rtracklayer::import(gtf)
gtf.df <- as.data.frame(gtf.rtl)

BPPARAM <- MulticoreParam(workers = cores)

# Importing counts
sampleData <- read.table(file = gzfile(anname), header = TRUE, row.names = NULL)
sampleData$sample_id <- paste(sampleData$sample_id, sampleData$condition, sep = "_")
sampleData$condition <- factor(sampleData$condition)
if (file_test("-d", sampleData$path[1])) {
    files <- file.path(sampleData$path, "quant.sf.gz")
} else {
    files <- sampleData$path
}
names(files) <- sampleData$sample_id

groups <- factor(sampleData$condition)
types <- factor(sampleData$type)
batches <- factor(sampleData$batch)

## Combinations of conditions
comparisons <- strsplit(cmp, ",")

## check combi
if (combi == "none") {
    combi <- ""
}

# Transcript-to-gene mapping
txdb.filename <- file.path(paste(gtf, "sqlite", sep = "."))
txdb <- makeTxDbFromGFF(gtf, format = "gtf")
txdf <- select(txdb, keys(txdb, "GENEID"), "TXNAME", "GENEID")
tab <- table(txdf$GENEID)
txdf$ntx <- tab[match(txdf$GENEID, names(tab))]

# get counts
txi <- tximport(files, type = "salmon", txOut = TRUE, countsFromAbundance = "scaledTPM")
cts <- txi$counts[rownames(txi$counts) %in% txdf$TXNAME, ] # We have to assume salmon was run with a decoy and do not want that in our cts table
cts <- cts[rowSums(cts) > 0, ]
cts.original <- cts
rownames(cts) <- sub("\\|.*", "", rownames(cts))

# check for integrity -> define exception..
all(rownames(cts) %in% txdf$TXNAME)
txdf <- txdf[match(rownames(cts), txdf$TXNAME), ]
all(rownames(cts) == txdf$TXNAME)

counts <- data.frame(gene_id = txdf$GENEID, feature_id = txdf$TXNAME, cts, check.names = FALSE)
counts <- counts[!is.na(counts$gene_id), ]
d <- dmDSdata(counts = counts, samples = sampleData)

# Filter before running procedures:
#   (1) it has a count of at least 10 in at least n.small samples
#   (2) it has a relative abundance proportion of at least 0.1 in at least n.small samples
#   (3) the total count of the corresponding gene is at least 10 in all n samples
n <- nrow(sampleData)
n.small <- n / length(levels(sampleData$condition)) # its not really the smallest group, needs to be improved
eval(parse(text = paste("d <- dmFilter(d,", filter, ")", sep = "")))

## shows how many of the remaining genes have N isoforms
# table(table(counts(d)$gene_id))

# create designmatrix
#   original code for simple model
design <- model.matrix(~groups, data = DRIMSeq::samples(d))

## name types and levels for design
# bl <- sapply("batch", paste0, levels(batches)[-1])
# tl <- sapply("type", paste0, levels(types)[-1])

## Create design-table considering different types (paired, unpaired) and batches
# if (length(levels(types)) > 1){
#    if (length(levels(batches)) > 1){
#        design <- model.matrix(~0+groups+types+batches, data=sampleData)
#        colnames(design) <- c(levels(groups),tl,bl)
#    } else{
#        design <- model.matrix(~0+groups+types, data=sampleData)
#        colnames(design) <- c(levels(groups),tl)
#    }
# } else{
#    if (length(levels(batches)) > 1){
#        design <- model.matrix(~0+groups+batches, data=sampleData)
#        colnames(design) <- c(levels(groups),bl)
#    } else{
#        design <- model.matrix(~0+groups, data=sampleData)
#        colnames(design) <- levels(groups)
#    }
# }

comparison_objs <- list()
setwd(outdir)

## Analyze according to comparison groups
for (contrast in comparisons[[1]]) {
    contrast_name <- strsplit(contrast, ":")[[1]][1]
    contrast_groups <- strsplit(strsplit(contrast, ":")[[1]][2], "-vs-")

    print(paste("Comparing ", contrast_name, sep = ""))

    # determine contrast
    A <- strsplit(contrast_groups[[1]][1], "\\+")
    B <- strsplit(contrast_groups[[1]][2], "\\+")
    minus <- 1 / length(A[[1]]) * (-1)
    plus <- 1 / length(B[[1]])
    contrast <- cbind(integer(dim(design)[2]), colnames(design))
    for (i in A[[1]]) {
        contrast[which(contrast[, 2] == i)] <- minus
    }
    for (i in B[[1]]) {
        contrast[which(contrast[, 2] == i)] <- plus
    }
    contrast <- as.numeric(contrast[, 1])

    # DEXSeq on DRIMSeq filtering
    sample.data <- DRIMSeq::samples(d)
    count.data <- round(as.matrix(counts(d)[, -c(1:2)]))
    # The design formula of the DEXSeqDataSet here uses the language “exon” but this should be read as “transcript” for our analysis.
    dxd <- DEXSeqDataSet(
        countData = count.data,
        sampleData = sample.data,
        design = ~ sample + exon + condition:exon,
        featureID = counts(d)$feature_id,
        groupID = counts(d)$gene_id
    )
    dxd <- DEXSeq::estimateSizeFactors(dxd)
    dxd <- DEXSeq::estimateDispersions(dxd, quiet = TRUE)
    dxd <- testForDEU(dxd, reducedModel = ~ sample + exon)

    dxr <- DEXSeqResults(dxd, independentFiltering = FALSE)
    qval <- perGeneQValue(dxr)
    dxr.g <- data.frame(gene = names(qval), qval)

    columns <- c("featureID", "groupID", "pvalue", "padj")
    dxr <- as.data.frame(dxr[, columns])

    dxr$Gene <- lapply(dxr$groupID, function(x) {
        get_gene_name(x, gtf.df)
    })
    dxr <- dxr[, c(1, 2, 5, 3, 4)]
    toprint <- as.data.frame(dxr)
    toprint$transcripts <- vapply(toprint$featureID, paste, collapse = ", ", character(1L))
    toprint$genes <- vapply(toprint$Gene, paste, collapse = ", ", character(1L))
    toprint <- subset(toprint, select = -c(Gene, featureID))

    write.table(toprint, gzfile(paste("Tables/DTU", "DEXSEQ", combi, contrast_name, "table", "results.tsv.gz", sep = "_")), sep = "\t", quote = F, row.names = FALSE)

    # # stageR following DEXSeq
    # strp <- function(x) substr(x,1,15)
    # pConfirmation <- matrix(dxr$pvalue,ncol=1)
    # dimnames(pConfirmation) <- list(strp(dxr$featureID),"transcript")
    # pScreen <- qval
    # names(pScreen) <- strp(names(pScreen))
    # tx2gene <- as.data.frame(dxr[,c("featureID", "groupID")])
    # for (i in 1:2) tx2gene[,i] <- strp(tx2gene[,i])
    #
    # stageRObj <- stageRTx(pScreen=pScreen, pConfirmation=pConfirmation,
    #                       pScreenAdjusted=TRUE, tx2gene=tx2gene)
    # stageRObj <- stageWiseAdjustment(stageRObj, method="dtu", alpha=0.05)
    # suppressWarnings({
    #   dex.padj <- getAdjustedPValues(stageRObj, order=FALSE,
    #                                  onlySignificantGenes=TRUE)
    # })

    # write.table(as.data.frame(dex.padj), gzfile(paste("DTU_DEXSEQ",contrast_name,"stageR-filtered.tsv.gz",sep="_")), sep="\t", quote=F, row.names=FALSE)
}

save.image(file = paste("DTU_DEXSEQ", combi, "SESSION.gz", sep = "_"), version = NULL, ascii = FALSE, compress = "gzip", safe = TRUE)

## FUNCS
get_gene_name <- function(id, df) {
    if (!"gene_id" %in% colnames(df)) {
        message("WARNING: gene_id not found as colname, will be replaced by first match of colname with ID")
        colnames(df)[grepl("id$", names(df), ignore.case = TRUE)][1] <- "gene_id"
    }
    name_list <- df$gene[df["type"] == "gene" & df["gene_id"] == id]
    if (length(unique(name_list)) == 1) {
        return(name_list[1])
    } else {
        message(paste("WARNING: ambigous gene id: ", id))
        return(paste(unique(name_list), sep = "|"))
    }
}


get_exon_name <- function(id, df) {
    if (!"gene_id" %in% colnames(df)) {
        message("WARNING: gene_id not found as colname, will be replaced by first match of colname with ID")
        colnames(df)[grepl("id$", names(df), ignore.case = TRUE)][1] <- "gene_id"
    }
    name_list <- df$gene[df["type"] == "exon" & df["gene_id"] == id]
    if (length(unique(name_list)) == 1) {
        return(name_list[1])
    } else {
        message(paste("WARNING: ambigous gene id: ", id))
        return(paste(unique(name_list), sep = "|"))
    }
}

suppressPackageStartupMessages({
    require(BiocParallel)
    library(tximport)
    library(GenomicFeatures)
    library(DRIMSeq)
    library(rtracklayer)
})

options(echo = TRUE)

### ARGS
args <- commandArgs(trailingOnly = TRUE)
argsLen <- length(args)
anname <- args[1]
gtf <- args[2]
outdir <- args[3]
cmp <- args[4]
combi <- args[5]
cores <- as.integer(args[6])
filter <- if (argsLen > 6) args[7] else "min_samps_feature_expr = 1, min_feature_expr = .1, min_samps_gene_expr = 1, min_gene_expr = 1"
print(args)

## FUNCS
libp <- paste0(gsub("/bin/conda", "/envs/monsda", Sys.getenv("CONDA_EXE")), "/share/MONSDA/scripts/lib/_lib.R")
source(libp)

### SCRIPT
# load gtf
gtf.rtl <- rtracklayer::import(gtf)
gtf.df <- as.data.frame(gtf.rtl)

BPPARAM <- MulticoreParam(workers = cores)

# Importing counts
sampleData <- read.table(file = gzfile(anname), header = TRUE, row.names = NULL)
sampleData$original_sample_id <- sampleData$sample_id
sampleData$sample_id <- paste("sample", sampleData$sample_id, sampleData$condition, sep = "_")
sampleData$sample_id <- make.names(sampleData$sample_id)
sampleData$condition <- as.factor(sampleData$condition)
sampleData$type <- as.factor(sampleData$type)
sampleData$batch <- as.factor(sampleData$batch)

if (file_test("-d", sampleData$path[1])) {
    files <- file.path(sampleData$path, "quant.sf.gz")
} else {
    files <- sampleData$path
}
names(files) <- sampleData$sample_id

## Combinations of conditions
comparisons <- strsplit(cmp, ",")

## check combi
if (combi == "none") {
    combi <- ""
}


# Transcript-to-gene mapping
txdb.filename <- file.path(paste(gtf, "sqlite", sep = "."))
txdb <- makeTxDbFromGFF(gtf, format = "gtf")
txdf <- select(txdb, keys(txdb, "GENEID"), "TXNAME", "GENEID")
tab <- table(txdf$GENEID)
txdf$ntx <- tab[match(txdf$GENEID, names(tab))]

# get counts
txi <- tximport(files, type = "salmon", txOut = TRUE, countsFromAbundance = "scaledTPM")
cts <- txi$counts[rownames(txi$counts) %in% txdf$TXNAME, ] # We have to assume salmon was run with a decoy and do not want that in our cts table
cts <- cts[rowSums(cts) > 0, ]
cts.original <- cts
rownames(cts) <- sub("\\|.*", "", rownames(cts))

# DRIMSEQ
# check for integrity -> define exception..
all(rownames(cts) %in% txdf$TXNAME)
txdf <- txdf[match(rownames(cts), txdf$TXNAME), ]
all(rownames(cts) == txdf$TXNAME)

counts <- data.frame(gene_id = txdf$GENEID, feature_id = txdf$TXNAME, cts, check.names = FALSE)
counts <- counts[!is.na(counts$gene_id), ]
d <- dmDSdata(counts = counts, samples = sampleData)

# Filter before running procedures:
#   (1) it has a count of at least 10 in at least n.small samples
#   (2) it has a relative abundance proportion of at least 0.1 in at least n.small samples
#   (3) the total count of the corresponding gene is at least 10 in all n samples
n <- nrow(sampleData)
n.small <- n / length(levels(sampleData$condition)) # its not really the smallest group, needs to be improved
eval(parse(text = paste("d <- dmFilter(d,", filter, ")", sep = "")))

## shows how many of the remaining genes have N isoforms
# table(table(counts(d)$gene_id))

# # create designmatrix
# #   original code for simple model
# design <- model.matrix(~0+sampleData$condition, data=sampleData)
# colnames(design) <- levels(sampleData$condition)

## make dataset smaller for testing
# d <- d[1:250,]

# name types and levels for design
bl <- sapply("batch", paste0, levels(sampleData$batch)[-1])
tl <- sapply("type", paste0, levels(sampleData$type)[-1])

# Create design-table considering different types (paired, unpaired) and batches
if (length(levels(sampleData$type)) > 1) {
    if (length(levels(sampleData$batch)) > 1) {
        design <- model.matrix(~ 0 + type + batch + condition, data = sampleData)
        colnames(design) <- c(tl, bl, levels(sampleData$condition))
    } else {
        design <- model.matrix(~ 0 + type + condition, data = sampleData)
        colnames(design) <- c(tl, levels(sampleData$condition))
    }
} else {
    if (length(levels(sampleData$batch)) > 1) {
        design <- model.matrix(~ 0 + batch + condition, data = sampleData)
        colnames(design) <- c(bl, levels(sampleData$condition))
    } else {
        design <- model.matrix(~ 0 + condition, data = sampleData)
        colnames(design) <- levels(sampleData$condition)
    }
}

comparison_objs <- list()
setwd(outdir)

## Analyze according to comparison groups
for (contrast in comparisons[[1]]) {
    contrast_name <- strsplit(contrast, ":")[[1]][1]
    contrast_groups <- strsplit(strsplit(contrast, ":")[[1]][2], "-vs-")

    print(paste("Comparing ", contrast_name, sep = ""))
    tryCatch({
        # determine contrast
        A <- strsplit(contrast_groups[[1]][1], "\\+")
        B <- strsplit(contrast_groups[[1]][2], "\\+")
        minus <- 1 / length(A[[1]]) * (-1)
        plus <- 1 / length(B[[1]])
        contrast <- cbind(integer(dim(design)[2]), colnames(design))
        for (i in A[[1]]) {
            contrast[which(contrast[, 2] == i)] <- minus
        }
        for (i in B[[1]]) {
            contrast[which(contrast[, 2] == i)] <- plus
        }
        contrast <- as.numeric(contrast[, 1])

        # 1 estimate the precision,
        # 2 fit regression coefficients and perform null hypothesis testing on the coefficient of interest,
        # 3 test the coefficient associated with the difference between condition 2 and condition 1
        set.seed(1)
        d <- dmPrecision(d, design = design, BPPARAM = BPPARAM)
        d <- dmFit(d, design = design)
        d <- dmTest(d, contrast = contrast)

        # add comp object to list for image
        comparison_objs[[contrast_name]] <- d

        # calculate LFC from proportions table
        proportions <- DRIMSeq::proportions(d)
        samples_of_group_A <- subset(samples(d), condition == A)$sample_id
        samples_of_group_B <- subset(samples(d), condition == B)$sample_id
        proportions[paste(A[[1]], "mean", sep = "_")] <- rowMeans(proportions[as.vector(samples_of_group_A)])
        proportions[paste(B[[1]], "mean", sep = "_")] <- rowMeans(proportions[as.vector(samples_of_group_B)])
        proportions["lfc"] <- log2(proportions[paste(A[[1]], "mean", sep = "_")]) - log2(proportions[paste(B[[1]], "mean", sep = "_")])
        props_transcripts <- proportions[c("feature_id", "lfc")]
        props_genes <- aggregate(proportions, list(proportions$gene_id), mean)[c("Group.1", "lfc")]
        colnames(props_genes) <- c("gene_id", "lfc")

        # generate a single p-value per gene and transcript
        res <- DRIMSeq::results(d)
        res.txp <- DRIMSeq::results(d, level = "feature")

        # filter out NA's
        no.na <- function(x) ifelse(is.na(x), 1, x)
        res$pvalue <- no.na(res$pvalue)
        res.txp$pvalue <- no.na(res.txp$pvalue)
        res$adj_pvalue <- no.na(res$adj_pvalue)
        res.txp$adj_pvalue <- no.na(res.txp$adj_pvalue)

        res <- merge(props_genes, res)
        res.txp <- merge(props_transcripts, res.txp)
        res <- res[, c(1, 6, 2, 3, 4, 5)]
        res.txp <- res.txp[, c(1, 7, 2, 3, 4, 5, 6)]

        proportions$Gene <- lapply(proportions$gene_id, function(x) {
            get_gene_name(x, gtf.df)
        })
        res$Gene <- lapply(res$gene_id, function(x) {
            get_gene_name(x, gtf.df)
        })
        res.txp$Gene <- lapply(res.txp$gene_id, function(x) {
            get_gene_name(x, gtf.df)
        })

        res <- res[order(res$adj_pvalue), ]
        res.txp <- res.txp[order(res$adj_pvalue), ]
        proportions <- proportions[order(proportions$lfc), ]

        proportions.print <- as.data.frame(apply(proportions, 2, as.character))
        for (c in 3:(length(colnames(proportions.print)) - 4)) {
            colnames(proportions.print)[c] <- sampleData$original_sample_id[sampleData$sample_id == colnames(proportions.print)[c]]
        }
        res.print <- as.data.frame(apply(res, 2, as.character))
        res.txp.print <- as.data.frame(apply(res.txp, 2, as.character))

        # CREATE RESULTS TABLES
        write.table(as.data.frame(proportions.print), gzfile(paste("Tables/DTU", "DRIMSEQ", combi, contrast_name, "table", "proportions.tsv.gz", sep = "_")), sep = "\t", quote = F, row.names = FALSE)
        write.table(as.data.frame(res.print), gzfile(paste("Tables/DTU", "DRIMSEQ", combi, contrast_name, "table", "genes.tsv.gz", sep = "_")), sep = "\t", quote = F, row.names = FALSE)
        write.table(as.data.frame(res.txp.print), gzfile(paste("Tables/DTU", "DRIMSEQ", combi, contrast_name, "table", "transcripts.tsv.gz", sep = "_")), sep = "\t", quote = F, row.names = FALSE)
        write.table(as.data.frame(genewise_precision(d)), gzfile(paste("Tables/DTU", "DRIMSEQ", combi, contrast_name, "table", "genewise-precision.tsv.gz", sep = "_")), sep = "\t", quote = F, row.names = FALSE)

        ## Plot feature per gene histogram
        tryCatch(
            {
                png(paste("Figures/DTU", "DRIMSEQ", combi, contrast_name, "figure", "FeatPerGene.png", sep = "_"))
                print(plotData(d))
                dev.off()
            },
            warning = function(w) {
                file.create(paste("Figures/DTU", "DRIMSEQ", combi, contrast_name, "figure", "FeatPerGene.png", sep = "_"))
                message("Caught a warning!")
                print(w)
            },
            error = function(e) {
                file.create(paste("Figures/DTU", "DRIMSEQ", combi, contrast_name, "figure", "FeatPerGene.png", sep = "_"))
            }
        )
        ## Plot precision
        png(paste("Figures/DTU", "DRIMSEQ", combi, contrast_name, "figure", "Precision.png", sep = "_"))
        print(plotPrecision(d))
        dev.off()

        ## Plot gene-level p-values
        png(paste("Figures/DTU", "DRIMSEQ", combi, contrast_name, "figure", "PValues.png", sep = "_"))
        print(plotPValues(d))
        dev.off()

        # plot proportions
        figures <- data.frame()
        sigs <- which(res$adj_pvalue < 0.05)

        limit <- 10
        counter <- 1
        message("create proportions plots")
        for (gene in sigs) {
            if (counter > limit) {
                break
            }
            if (is.na(gene)) {
                next
            }
            name1 <- paste("Figures/DTU", "DRIMSEQ", combi, contrast_name, res$Gene[gene], "figure", "plotProportions", "props.png", sep = "_")
            png(name1)
            print(plotProportions(d, res$gene_id[gene], group_variable = "condition"))
            dev.off()

            name2 <- paste("Figures/DTU", "DRIMSEQ", combi, contrast_name, res$Gene[gene], "figure", "lineplot.png", sep = "_")
            png(name2)
            print(plotProportions(d, res$gene_id[gene], group_variable = "condition", plot_type = "lineplot"))
            dev.off()

            name3 <- paste("Figures/DTU", "DRIMSEQ", combi, contrast_name, res$Gene[gene], "figure", "ribbonplot.png", sep = "_")
            png(name3)
            print(plotProportions(d, res$gene_id[gene], group_variable = "condition", plot_type = "ribbonplot"))
            dev.off()

            figures <- rbind(figures, c(res$gene_id[gene], res$Gene[gene], paste(outdir, name1, sep = "/")))
            figures <- rbind(figures, c(res$gene_id[gene], res$Gene[gene], paste(outdir, name2, sep = "/")))
            figures <- rbind(figures, c(res$gene_id[gene], res$Gene[gene], paste(outdir, name3, sep = "/")))

            counter <- counter + 1
        }
        tryCatch(
            {
                colnames(figures) <- c("geneID", "geneName", "file")
                write.table(figures, paste("Figures/DTU", "DRIMSEQ", combi, contrast_name, "list", "sigGeneFigures.tsv", sep = "_"), sep = "\t", quote = F, row.names = FALSE, col.names = TRUE)
            },
            warning = function(w) {
                file.create(paste("Figures/DTU", "DRIMSEQ", combi, contrast_name, "list", "sigGeneFigures.tsv", sep = "_"))
                message("Caught a warning!")
                print(w)
            },
            error = function(e) {
                file.create(paste("Figures/DTU", "DRIMSEQ", combi, contrast_name, "list", "sigGeneFigures.tsv", sep = "_"))
            }
        )

        sigt <- which(res.txp$adj_pvalue < 0.05)
        figures <- data.frame()
        limit <- 10
        counter <- 1
        message("create proportions plots for transcripts")
        for (trans in sigt) {
            if (counter > limit) {
                break
            }
            if (is.na(trans)) {
                next
            }
            name1 <- paste("Figures/DTU", "DRIMSEQ", combi, contrast_name, res.txp$Gene[trans], res.txp$feature_id[trans], "figure", "plotProportions_transcript", "props.png", sep = "_")
            png(name1)
            print(plotProportions(d, res.txp$gene_id[trans], group_variable = "condition"))
            dev.off()

            name2 <- paste("Figures/DTU", "DRIMSEQ", combi, contrast_name, res.txp$Gene[trans], res.txp$feature_id[trans], "figure", "lineplot_transcript.png", sep = "_")
            png(name2)
            print(plotProportions(d, res.txp$gene_id[trans], group_variable = "condition", plot_type = "lineplot"))
            dev.off()

            name3 <- paste("Figures/DTU", "DRIMSEQ", combi, contrast_name, res.txp$Gene[trans], res.txp$feature_id[trans], "figure", "ribbonplot_transcript.png", sep = "_")
            png(name3)
            print(plotProportions(d, res.txp$gene_id[trans], group_variable = "condition", plot_type = "ribbonplot"))
            dev.off()

            figures <- rbind(figures, c(res.txp$feature_id[trans], res.txp$Gene[trans], paste(outdir, name1, sep = "/")))
            figures <- rbind(figures, c(res.txp$feature_id[trans], res.txp$Gene[trans], paste(outdir, name2, sep = "/")))
            figures <- rbind(figures, c(res.txp$feature_id[trans], res.txp$Gene[trans], paste(outdir, name3, sep = "/")))

            counter <- counter + 1
        }
        tryCatch(
            {
                colnames(figures) <- c("transcriptID", "geneName", "file")
                write.table(figures, paste("Figures/DTU", "DRIMSEQ", combi, contrast_name, "list", "sigTranscriptFigures.tsv", sep = "_"), sep = "\t", quote = F, row.names = FALSE, col.names = TRUE)
            },
            warning = function(w) {
                file.create(paste("Figures/DTU", "DRIMSEQ", combi, contrast_name, "list", "sigTranscriptFigures.tsv", sep = "_"))
                message("Caught a warning!")
                print(w)
            },
            error = function(e) {
                file.create(paste("Figures/DTU", "DRIMSEQ", combi, contrast_name, "list", "sigTranscriptFigures.tsv", sep = "_"))
            }
        )

        # cleanup
        rm(res, res.txp, proportions)
        print(paste("cleanup done for ", contrast_name, sep = ""))
    })
}

save.image(file = paste("DTU_DRIMSEQ", combi, "SESSION.gz", sep = "_"), version = NULL, ascii = FALSE, compress = "gzip", safe = TRUE)

suppressPackageStartupMessages({
    require(BiocParallel)
    require(dplyr)
    require(edgeR)
    library(rtracklayer)
})

options(echo=TRUE)

## ARGS
args <- commandArgs(trailingOnly = TRUE)
anname          <- args[1]
countfile       <- args[2]
gtf             <- args[3]
outdir          <- args[4]
combi           <- args[5]
cmp             <- args[6]
availablecores  <- as.integer(args[7])
print(args)

### FUNCS
get_gene_name <- function(id, df){
    name_list <- df$gene_name[df['gene_id'] == id]
    if(length(unique(name_list)) == 1){
        return(name_list[1])
    }else{
        message(paste("WARNING: ambigous gene id: ", id))
        return (paste(unique(name_list), sep="|"))
    }
}

### SCRIPT
print(paste('Will run EdgeR DEU with ',availablecores,' cores',sep=''))

## set thread-usage
BPPARAM = MulticoreParam(workers=availablecores)

# load gtf
gtf.rtl <- rtracklayer::import(gtf)
gtf.df <- as.data.frame(gtf.rtl)
gtf_gene <- droplevels(subset(gtf.df, type == "gene"))

## Annotation
sampleData_all <- as.data.frame(read.table(gzfile(anname), row.names=1))
colnames(sampleData_all) <- c("condition", "type", "batch")
sampleData_all$condition <- as.factor(sampleData_all$condition)
sampleData_all$batch <- as.factor(sampleData_all$batch)
sampleData_all$type <- as.factor(sampleData_all$type)
samples <- rownames(sampleData_all)

## Combinations of conditions
comparisons <- strsplit(cmp, ",")

## check combi
if (combi == "none"){
    combi <- ''
}

## readin counttable
countData_all <- read.table(countfile, header = TRUE, row.names=1)

#Check if names are consistent
if (!all(rownames(sampleData_all) %in% colnames(countData_all))){
    stop("Count file does not correspond to the annotation file")
}

comparison_objs <- list()

WD <- getwd()
setwd(outdir)

## Analyze according to comparison groups
for(compare in comparisons[[1]]){

    contrast_name <- strsplit(compare, ":")[[1]][1]
    contrast_groups <- strsplit(strsplit(compare, ":")[[1]][2], "-vs-")

    print(paste("Comparing ", contrast_name, sep=""))

    # determine contrast
    A <- unlist(strsplit(contrast_groups[[1]][1], "\\+"), use.names=FALSE)
    B <- unlist(strsplit(contrast_groups[[1]][2], "\\+"), use.names=FALSE)

    #subset Datasets for pairwise comparison
    countData <- cbind(countData_all[ , grepl( paste(B, '_', sep='') , colnames( countData_all ) )], countData_all[ ,grepl(paste(A, '_', sep='') , colnames( countData_all )) ])
    sampleData <- droplevels(rbind(subset(sampleData_all, B == condition), subset(sampleData_all, A == condition)))
    sampleData$condition <- relevel(sampleData$condition, ref=B)
    samples <- rownames(sampleData)

    ## name types and levels for design
    bl <- sapply("batch", paste0, levels(sampleData$batch)[1:length(levels(sampleData$batch))-1])
    tl <- sapply("type", paste0, levels(sampleData$type)[1:length(levels(sampleData$type))-1])

    ## Create design-table considering different types (paired, unpaired) and batches
    if (length(unique(subset(sampleData, A == condition)$type)) > 1 | length(unique(subset(sampleData, B == condition)$type)) > 1){
        if (length(unique(subset(sampleData, A == condition)$batch)) > 1 | length(unique(subset(sampleData, B == condition)$batch)) > 1){
            des <- ~type+batch+condition
            design <- model.matrix(des, data=sampleData)
            # colnames(design) <- c(levels(sampleData$condition), tl, bl)
        } else{
            des <- ~type+condition
            design <- model.matrix(des, data=sampleData)
            # colnames(design) <- c(levels(condition), tl)
        }
    } else{
        if (length(unique(subset(sampleData, A == condition)$batch)) > 1 | length(unique(subset(sampleData, B == condition)$batch)) > 1){
            des <- ~batch+condition
            design <- model.matrix(des, data=sampleData)
            # colnames(design) <- c(levels(sampleData$condition), bl)
        } else{
            des <- ~condition
            design <- model.matrix(des, data=sampleData)
            # colnames(design) <- levels(sampleData$condition)
        }
    }
    print(design)

    ## get genes names out
    genes <- rownames(countData)

    splitted <- strsplit(rownames(countData), ":")
    exons <- sapply(splitted, "[[", 2)
    genesrle <- sapply(splitted, "[[", 1)

    dge <- DGEList(counts=countData, group=sampleData$condition, samples=samples, genes=genesrle)

    ## Addd exons to dge
    dge$genes$exons <- exons

    ## filter low counts
    keep <- filterByExpr(dge)
    dge <- dge[keep, , keep.lib.sizes=FALSE]

    #relevel to base condition B
    dge$samples$group <- relevel(dge$samples$group, ref = B[[1]])

    ## normalize with TMM
    dge <- calcNormFactors(dge, method = "TMM", BPPARAM=BPPARAM)


    ## create file normalized table
    tmm <- as.data.frame(cpm(dge))
    colnames(tmm) <- t(dge$samples$samples)
    tmm$ID <- dge$genes$genes
    tmm <- tmm[c(ncol(tmm),1:ncol(tmm)-1)]

    write.table(as.data.frame(tmm), gzfile(paste("Tables/DEU", "EDGER",combi, contrast_name, "DataSet", "table", "Normalized.tsv.gz",sep="_")), sep="\t", quote=F, row.names=FALSE)

    ## create file MDS-plot with and without summarized replicates
    out <- paste("Figures/DEU", "EDGER",combi,contrast_name, "DataSet", "figure", "MDS.png", sep="_")
    png(out)
    plotMDS(dge, col = as.numeric(dge$samples$group), cex = 1)
    dev.off()

    ## estimate Dispersion
    dge <- estimateDisp(dge, design, robust=TRUE)

    ## create file BCV-plot - visualizing estimated dispersions
    out <- paste("Figures/DEU","EDGER",combi, contrast_name,"DataSet", "figure", "BCV.png", sep="_")
    png(out, width = 400, height = 400)
    plotBCV(dge)
    dev.off()

    ## fitting a quasi-likelihood negative binomial generalized log-linear model to counts
    fit <- glmQLFit(dge, design, robust=TRUE)

    ## create file quasi-likelihood-dispersion-plot
    out <- paste("Figures/DEU","EDGER",combi,contrast_name, "DataSet", "figure", "QLDisp.png", sep="_")
    png(out, width = 400, height = 400)
    plotQLDisp(fit)
    dev.off()

    tryCatch({

        # # determine contrast
        # A <- strsplit(contrast_groups[[1]][1], "\\+")
        # B <- strsplit(contrast_groups[[1]][2], "\\+")
        # minus <- 1/length(A[[1]])*(-1)
        # plus <- 1/length(B[[1]])
        # contrast <- cbind(integer(dim(design)[2]), colnames(design))
        # for(i in A[[1]]){
        #     contrast[which(contrast[,2]==i)]<- minus
        # }
        # for(i in B[[1]]){
        #     contrast[which(contrast[,2]==i)]<- plus
        # }
        # contrast <- as.numeric(contrast[,1])

        # quasi-likelihood F-Test
        # qlf <- glmQLFTest(fit, contrast = contrast)
        qlf <- glmQLFTest(fit)
        is.de <- decideTests(qlf, p.value=0.05)

        # add comp object to list for image
        comparison_objs[[contrast_name]] <- qlf

        # # Add gene names  (check how gene_id col is named )
        qlf$table$Gene  <- lapply(qlf$genes$genes, function(x){get_gene_name(x, gtf_gene)})
        qlf$table$Gene_ID <- qlf$genes$genes
        qlf$table$ExonPos <- qlf$genes$exons
        res <- qlf$table[, c(6,5,7,1,2,3,4)]
        res <- as.data.frame(apply(res,2, as.character))

        # create results table
        write.table(as.data.frame(res), gzfile(paste("Tables/DEU","EDGER",combi,contrast_name, "table","results.tsv.gz", sep="_")), sep="\t", quote=F, row.names=FALSE)

        ## plot lFC vs CPM
        out <- paste("Figures/DEU","EDGER",combi,contrast_name, "figure","MD.png",sep="_")
        png(out)
        plotMD(qlf, main=contrast_name)
        abline(h=c(-1, 1), col="blue")
        dev.off()

        # cleanup
        rm(qlf, BPPARAM)
        print(paste('cleanup done for ', contrast_name, sep=''))

    })
}

## Create design-table considering different types (paired, unpaired) and batches
des <- ~0+condition
design <- model.matrix(des, data=sampleData_all)
colnames(design) <- levels(sampleData_all$condition)
print(design)

genes <- rownames(countData_all)
samples <- rownames(sampleData_all)

splitted <- strsplit(rownames(countData_all), ":")
exons <- sapply(splitted, "[[", 2)
genesrle <- sapply(splitted, "[[", 1)

dge <- DGEList(counts=countData_all, group=sampleData_all$condition, samples=samples, genes=genesrle)

## Addd exons to dge
dge$genes$exons <- exons

## filter low counts
keep <- filterByExpr(dge)
dge <- dge[keep, , keep.lib.sizes=FALSE]

## normalize with TMM
dge <- calcNormFactors(dge, method = "TMM", BPPARAM=BPPARAM)


## create file normalized table
tmm <- as.data.frame(cpm(dge))
colnames(tmm) <- t(dge$samples$samples)
tmm$ID <- dge$genes$genes
tmm <- tmm[c(ncol(tmm),1:ncol(tmm)-1)]

write.table(as.data.frame(tmm), gzfile(paste("Tables/DEU", "EDGER",combi, "DataSet", "table", "AllConditionsNormalized.tsv.gz",sep="_")), sep="\t", quote=F, row.names=FALSE)

## create file MDS-plot with and without summarized replicates
out <- paste("Figures/DEU", "EDGER",combi, "DataSet", "figure", "AllConditionsMDS.png", sep="_")
png(out)
plotMDS(dge, col = as.numeric(dge$samples$group), cex = 1)
dev.off()

## estimate Dispersion
dge <- estimateDisp(dge, design, robust=TRUE)

## create file BCV-plot - visualizing estimated dispersions
out <- paste("Figures/DEU","EDGER",combi, "DataSet", "figure", "AllConditionsBCV.png", sep="_")
png(out, width = 400, height = 400)
plotBCV(dge)
dev.off()

## fitting a quasi-likelihood negative binomial generalized log-linear model to counts
fit <- glmQLFit(dge, design, robust=TRUE)

## create file quasi-likelihood-dispersion-plot
out <- paste("Figures/DEU","EDGER",combi, "DataSet", "figure", "AllConditionsQLDisp.png", sep="_")
png(out, width = 400, height = 400)
plotQLDisp(fit)
dev.off()


save.image(file = paste("DEU_EDGER",combi, "SESSION.gz",sep="_"), version = NULL, ascii = FALSE, compress = "gzip", safe = TRUE)

suppressPackageStartupMessages({
    require(utils)
    require(BiocParallel)
    require(edgeR)
    require(rtracklayer)
    require(RUVSeq)
    require(dplyr)
    require(GenomeInfoDb)
})

options(echo = TRUE)

## ARGS
args <- commandArgs(trailingOnly = TRUE)
argsLen <- length(args)
anname <- args[1]
countfile <- args[2]
gtf <- args[3]
outdir <- args[4]
cmp <- args[5]
combi <- args[6]
availablecores <- as.integer(args[7])
spike <- if (argsLen > 7) args[8] else ""

print(args)

## FUNCS
libp <- paste0(gsub("/bin/conda", "/envs/monsda", Sys.getenv("CONDA_EXE")), "/share/MONSDA/scripts/lib/_lib.R")
source(libp)

### SCRIPT
print(paste("Run EdgeR DE with ", availablecores, " cores", sep = ""))

# set thread-usage
BPPARAM <- MulticoreParam(workers = availablecores)

# load gtf
gtf.rtl <- rtracklayer::import(gtf)
gtf.df <- as.data.frame(gtf.rtl)
gtf_gene <- droplevels(subset(gtf.df, type == "gene"))

## Annotation
sampleData_all <- as.data.frame(read.table(gzfile(anname), row.names = 1, check.names = FALSE))
colnames(sampleData_all) <- c("condition", "type", "batch")
sampleData_all$condition <- as.factor(sampleData_all$condition)
sampleData_all$batch <- as.factor(sampleData_all$batch)
sampleData_all$type <- as.factor(sampleData_all$type)
samples <- rownames(sampleData_all)

## Combinations of conditions
comparison <- strsplit(cmp, ",")

## check combi
if (combi == "none") {
    combi <- ""
}

## readin counttable
countData_all <- read.table(countfile, header = TRUE, row.names = 1, check.names = FALSE)

# Check if names are consistent
if (!all(rownames(sampleData_all) %in% colnames(countData_all))) {
    stop("Count file does not correspond to the annotation file")
}

comparison_objs <- list()

WD <- getwd()
setwd(outdir)

## Analyze according to comparison groups
for (contrast in comparison[[1]]) {
    contrast_name <- strsplit(contrast, ":")[[1]][1]
    contrast_groups <- strsplit(strsplit(contrast, ":")[[1]][2], "-vs-")

    print(paste("Comparing ", contrast_name, sep = ""))

    # determine contrast
    A <- unlist(strsplit(contrast_groups[[1]][1], "\\+"), use.names = FALSE)
    B <- unlist(strsplit(contrast_groups[[1]][2], "\\+"), use.names = FALSE)

    # subset Datasets for pairwise comparison
    countData <- cbind(countData_all[, grepl(paste("^", B, "_", sep = ""), colnames(countData_all))], countData_all[, grepl(paste("^", A, "_", sep = ""), colnames(countData_all))])
    sampleData <- droplevels(rbind(subset(sampleData_all, B == condition), subset(sampleData_all, A == condition)))
    sampleData$condition <- relevel(sampleData$condition, ref = B)

    samples <- rownames(sampleData)
    ## name types and levels for design
    bl <- sapply("batch", paste0, levels(sampleData$batch)[1:length(levels(sampleData$batch)) - 1])
    tl <- sapply("type", paste0, levels(sampleData$type)[1:length(levels(sampleData$type)) - 1])

    ## Create design-table considering different types (paired, unpaired) and batches
    if (length(unique(subset(sampleData, A == condition)$type)) > 1 | length(unique(subset(sampleData, B == condition)$type)) > 1) {
        if (length(unique(subset(sampleData, A == condition)$batch)) > 1 | length(unique(subset(sampleData, B == condition)$batch)) > 1) {
            des <- ~ type + batch + condition
            design <- model.matrix(des, data = sampleData)
            # colnames(design) <- c(levels(sampleData$condition), tl, bl)
        } else {
            des <- ~ type + condition
            design <- model.matrix(des, data = sampleData)
            # colnames(design) <- c(levels(condition), tl)
        }
    } else {
        if (length(unique(subset(sampleData, A == condition)$batch)) > 1 | length(unique(subset(sampleData, B == condition)$batch)) > 1) {
            des <- ~ batch + condition
            design <- model.matrix(des, data = sampleData)
            # colnames(design) <- c(levels(sampleData$condition), bl)
        } else {
            des <- ~condition
            design <- model.matrix(des, data = sampleData)
            # colnames(design) <- levels(sampleData$condition)
        }
    }
    print(design)

    ## check genes and spike-ins
    if (spike != "") {
        print("Spike-in used, data will be normalized to spike in separately")
        spike <- strsplit(spike, "=")[[1]][2]
        setwd(WD)
        ctrlgenes <- readLines(spike)
        setwd(outdir)
        counts_norm <- RUVg(newSeqExpressionSet(as.matrix(countData)), ctrlgenes, k = 1)
        genes <- rownames(countData)
        countData <- countData %>% subset(!row.names(countData) %in% ctrlgenes) # removing spike-ins for standard analysis

        sampleData_norm <- cbind(sampleData, pData(counts_norm))
        design_norm <- model.matrix(as.formula(paste(deparse(des), colnames(pData(counts_norm))[1], sep = " + ")), data = sampleData_norm)
        # colnames(design_norm) <- c(colnames(design),"W_1")

        dge_norm <- DGEList(counts = counts(counts_norm), group = sampleData$condition, samples = samples, genes = genes)

        ## filter low counts
        keep <- filterByExpr(dge_norm)
        dge_norm <- dge_norm[keep, , keep.lib.sizes = FALSE]

        # relevel to base condition B
        dge_norm$samples$group <- relevel(dge_norm$samples$group, ref = B[[1]])

        ## normalize with TMM
        dge_norm <- calcNormFactors(dge_norm, method = "TMM", BPPARAM = BPPARAM)

        ## create file normalized table
        tmm_norm <- as.data.frame(cpm(dge_norm))
        colnames(tmm_norm) <- t(dge_norm$samples$samples)
        tmm_norm$ID <- dge_norm$genes$genes
        tmm_norm <- tmm_norm[c(ncol(tmm_norm), 1:ncol(tmm_norm) - 1)]

        write.table(as.data.frame(tmm_norm), gzfile(paste("Tables/DE", "EDGER", combi, contrast_name, "DataSet", "table", "Normalized_norm.tsv.gz", sep = "_")), sep = "\t", quote = F, row.names = FALSE)

        ## create file MDS-plot with and without summarized replicates
        out <- paste("Figures/DE", "EDGER", combi, contrast_name, "DataSet", "figure", "MDS_norm.png", sep = "_")
        png(out)
        plotMDS(dge_norm, col = as.numeric(dge_norm$samples$group), cex = 1)
        dev.off()

        ## estimate Dispersion
        dge_norm <- estimateDisp(dge_norm, design_norm, robust = TRUE)

        ## create file BCV-plot - visualizing estimated dispersions
        out <- paste("Figures/DE", "EDGER", combi, contrast_name, "DataSet", "figure", "BCV_norm.png", sep = "_")
        png(out)
        plotBCV(dge_norm)
        dev.off()

        ## fitting a quasi-likelihood negative binomial generalized log-linear model to counts
        fit_norm <- glmQLFit(dge_norm, design_norm, robust = TRUE)

        ## create file quasi-likelihood-dispersion-plot
        out <- paste("Figures/DE", "EDGER", combi, contrast_name, "DataSet", "figure", "QLDisp_norm.png", sep = "_")
        png(out)
        plotQLDisp(fit_norm)
        dev.off()
    }

    # Same without spike-in normalization
    genes <- rownames(countData)
    dge <- DGEList(counts = countData, group = sampleData$condition, samples = samples, genes = genes)

    ## filter low counts
    keep <- filterByExpr(dge)
    dge <- dge[keep, , keep.lib.sizes = FALSE]

    # relevel to base condition B
    dge$samples$group <- relevel(dge$samples$group, ref = B[[1]])

    ## normalize with TMM
    dge <- calcNormFactors(dge, method = "TMM", BPPARAM = BPPARAM)

    ## create file normalized table
    tmm <- as.data.frame(cpm(dge))
    colnames(tmm) <- t(dge$samples$samples)
    tmm$ID <- dge$genes$genes
    tmm <- tmm[c(ncol(tmm), 1:ncol(tmm) - 1)]

    write.table(as.data.frame(tmm), gzfile(paste("Tables/DE", "EDGER", combi, contrast_name, "DataSet", "table", "Normalized.tsv.gz", sep = "_")), sep = "\t", quote = F, row.names = FALSE)

    ## create file MDS-plot with and without summarized replicates
    out <- paste("Figures/DE", "EDGER", combi, contrast_name, "DataSet", "figure", "MDS.png", sep = "_")
    png(out)
    plotMDS(dge, col = as.numeric(dge$samples$group), cex = 1)
    dev.off()

    ## estimate Dispersion
    dge <- estimateDisp(dge, design, robust = TRUE)

    ## create file BCV-plot - visualizing estimated dispersions
    out <- paste("Figures/DE", "EDGER", combi, contrast_name, "DataSet", "figure", "BCV.png", sep = "_")
    png(out)
    plotBCV(dge)
    dev.off()

    ## fitting a quasi-likelihood negative binomial generalized log-linear model to counts
    fit <- glmQLFit(dge, design, robust = TRUE)

    ## create file quasi-likelihood-dispersion-plot
    out <- paste("Figures/DE", "EDGER", combi, contrast_name, "DataSet", "figure", "QLDisp.png", sep = "_")
    png(out)
    plotQLDisp(fit)
    dev.off()

    tryCatch({
        # determine contrast, only for complex cases, not needed for our pairwise comparisons now
        # A <- strsplit(contrast_groups[[1]][1], "\\+")
        # B <- strsplit(contrast_groups[[1]][2], "\\+")
        # minus <- 1/length(A[[1]])*(-1)
        # plus <- 1/length(B[[1]])
        # contrast <- cbind(integer(dim(design)[2]), colnames(design))
        # for(i in A[[1]]){
        #    contrast[which(contrast[,2]==i)]<- minus
        # }
        # for(i in B[[1]]){
        #    contrast[which(contrast[,2]==i)]<- plus
        # }
        # contrast <- as.numeric(contrast[,1])

        ## Testing
        # qlf <- glmQLFTest(fit, contrast=contrast) ## glm quasi-likelihood-F-Test
        AvsB <- makeContrasts(TreatvsUntreat = paste("condition", A, sep = ""), levels = design)
        qlf <- glmQLFTest(fit, contrast = AvsB) ## glm quasi-likelihood-F-Test
        # add comp object to list for image
        comparison_objs[[contrast_name]] <- qlf

        # # Add gene names  (check how gene_id col is named )
        qlf$table$Gene <- lapply(rownames(qlf$table), function(x) {
            get_gene_name(x, gtf_gene)
        })
        qlf$table$Gene_ID <- rownames(qlf$table)
        res <- qlf$table[, c(6, 5, 2, 1, 3, 4)]
        res$FDR <- p.adjust(res$PValue, method = "BH")
        res <- as.data.frame(apply(res, 2, as.character))

        # create results table
        write.table(as.data.frame(res), gzfile(paste("Tables/DE", "EDGER", combi, contrast_name, "table", "results.tsv.gz", sep = "_")), sep = "\t", quote = F, row.names = FALSE)

        # create sorted results Tables
        tops <- topTags(qlf, n = nrow(qlf$table), sort.by = "logFC")
        tops <- tops$table[, c(7, 6, 3, 2, 4, 5, 8)]
        tops <- as.data.frame(apply(tops, 2, as.character))
        write.table(tops, gzfile(paste("Tables/DE", "EDGER", combi, contrast_name, "table", "resultsLogFCsorted.tsv.gz", sep = "_")), sep = "\t", quote = F, row.names = FALSE)

        tops <- topTags(qlf, n = nrow(qlf$table), sort.by = "PValue")
        tops <- tops$table[, c(7, 6, 3, 2, 4, 5, 8)]
        tops <- as.data.frame(apply(tops, 2, as.character))
        write.table(tops, gzfile(paste("Tables/DE", "EDGER", combi, contrast_name, "table", "resultsPValueSorted.tsv.gz", sep = "_")), sep = "\t", quote = F, row.names = FALSE)

        ## plot lFC vs CPM
        out <- paste("Figures/DE", "EDGER", combi, contrast_name, "figure", "MD.png", sep = "_")
        png(out)
        plotMD(qlf, main = contrast_name)
        abline(h = c(-1, 1), col = "blue")
        dev.off()

        if (spike != "") { # Same for spike-in normalized
            rm(qlf, tops, res)

            # determine contrast, only for complex cases, not needed for our pairwise comparisons now
            # A <- strsplit(contrast_groups[[1]][1], "\\+")
            # B <- strsplit(contrast_groups[[1]][2], "\\+")
            # minus <- 1/length(A[[1]])*(-1)
            # plus <- 1/length(B[[1]])
            # contrast <- cbind(integer(dim(design)[2]), colnames(design))
            # for(i in A[[1]]){
            #    contrast[which(contrast[,2]==i)]<- minus
            # }
            # for(i in B[[1]]){
            #    contrast[which(contrast[,2]==i)]<- plus
            # }
            # contrast <- as.numeric(contrast[,1])

            ## Testing
            # qlf <- glmQLFTest(fit, contrast=contrast) ## glm quasi-likelihood-F-Test
            AvsB <- makeContrasts(TreatvsUntreat = paste("condition", A, sep = ""), levels = design)
            qlf <- glmQLFTest(fit, contrast = AvsB) ## glm quasi-likelihood-F-Test
            # add comp object to list for image
            comparison_objs <- append(comparison_objs, qlf)

            # # Add gene names  (check how gene_id col is named )
            qlf$table$Gene <- lapply(rownames(qlf$table), function(x) {
                get_gene_name(x, gtf_gene)
            })
            qlf$table$Gene_ID <- rownames(qlf$table)
            res <- qlf$table[, c(6, 5, 1, 2, 3, 4)]
            res <- as.data.frame(apply(res, 2, as.character))

            # create results table
            write.table(as.data.frame(res), gzfile(paste("Tables/DE", "EDGER", combi, contrast_name, "table", "results_norm.tsv.gz", sep = "_")), sep = "\t", quote = F, row.names = FALSE)

            # create sorted results Tables
            tops <- topTags(qlf, n = nrow(qlf$table), sort.by = "logFC")
            tops <- tops$table[, c(7, 6, 4, 2, 3, 5, 8)]
            tops <- as.data.frame(apply(tops, 2, as.character))
            write.table(tops, gzfile(paste("Tables/DE", "EDGER", combi, contrast_name, "table", "resultsLogFCsorted_norm.tsv.gz", sep = "_")), sep = "\t", quote = F, row.names = FALSE)

            tops <- topTags(qlf, n = nrow(qlf$table), sort.by = "PValue")
            tops <- tops$table[, c(7, 6, 4, 2, 3, 5, 8)]
            tops <- as.data.frame(apply(tops, 2, as.character))
            write.table(tops, gzfile(paste("Tables/DE", "EDGER", combi, contrast_name, "table", "resultsPValueSorted_norm.tsv.gz", sep = "_")), sep = "\t", quote = F, row.names = FALSE)

            ## plot lFC vs CPM
            out <- paste("Figures/DE", "EDGER", combi, contrast_name, "figure", "MD_norm.png", sep = "_")
            png(out)
            plotMD(qlf, main = contrast_name)
            abline(h = c(-1, 1), col = "blue")
            dev.off()
        }

        # cleanup
        rm(qlf, res, tops)
        print(paste("cleanup done for ", contrast_name, sep = ""))
    })
}

# Same for all samples without design specific normalization
## name types and levels for design

## Create design-table considering different types (paired, unpaired) and batches
des <- ~ 0 + condition
design <- model.matrix(des, data = sampleData_all)
colnames(design) <- levels(sampleData_all$condition)
print(design)

genes <- rownames(countData_all)
samples <- rownames(sampleData_all)

dge <- DGEList(counts = countData_all, group = sampleData_all$condition, samples = samples, genes = genes)

## filter low counts
keep <- filterByExpr(dge)
dge <- dge[keep, , keep.lib.sizes = FALSE]

## normalize with TMM
dge <- calcNormFactors(dge, method = "TMM", BPPARAM = BPPARAM)

## create file normalized table
tmm <- as.data.frame(cpm(dge))
colnames(tmm) <- t(dge$samples$samples)
tmm$ID <- dge$genes$genes
tmm <- tmm[c(ncol(tmm), 1:ncol(tmm) - 1)]

write.table(as.data.frame(tmm), gzfile(paste("Tables/DE", "EDGER", combi, "DataSet", "table", "AllConditionsNormalized.tsv.gz", sep = "_")), sep = "\t", quote = F, row.names = FALSE)

## create file MDS-plot with and without summarized replicates
out <- paste("Figures/DE", "EDGER", combi, "DataSet", "figure", "AllConditionsMDS.png", sep = "_")
png(out)
plotMDS(dge, col = as.numeric(dge$samples$group), cex = 1)
dev.off()

## estimate Dispersion
dge <- estimateDisp(dge, design, robust = TRUE)

## create file BCV-plot - visualizing estimated dispersions
out <- paste("Figures/DE", "EDGER", combi, "DataSet", "figure", "AllConditionsBCV.png", sep = "_")
png(out)
plotBCV(dge)
dev.off()

## fitting a quasi-likelihood negative binomial generalized log-linear model to counts
fit <- glmQLFit(dge, design, robust = TRUE)

## create file quasi-likelihood-dispersion-plot
out <- paste("Figures/DE", "EDGER", combi, "DataSet", "figure", "AllConditionsQLDisp.png", sep = "_")
png(out)
plotQLDisp(fit)
dev.off()

save.image(file = paste("DE_EDGER", combi, "SESSION.gz", sep = "_"), version = NULL, ascii = FALSE, compress = "gzip", safe = TRUE)

# https://dwheelerau.com/2014/02/17/how-to-use-deseq2-to-analyse-rnaseq-data/

suppressPackageStartupMessages({
    require(utils)
    require(BiocParallel)
    require(DESeq2)
    require(ggrepel)
    require(ggplot2)
    require(rtracklayer)
    require(RUVSeq)
    require(dplyr)
    require(GenomeInfoDb)
    require(apeglm)
})

options(echo = TRUE)

## ARGS
args <- commandArgs(trailingOnly = TRUE)
argsLen <- length(args)
anname <- args[1]
countfile <- args[2]
gtf <- args[3]
outdir <- args[4]
cmp <- args[5]
combi <- args[6]
availablecores <- as.integer(args[7])
spike <- if (argsLen > 7) args[8] else ""

print(args)

## FUNCS
libp <- paste0(gsub("/bin/conda", "/envs/monsda", Sys.getenv("CONDA_EXE")), "/share/MONSDA/scripts/lib/_lib.R")
source(libp)

## set thread-usage
BPPARAM <- MulticoreParam(workers = availablecores)

### SCRIPT
## Annotation
sampleData_all <- as.data.frame(read.table(gzfile(anname), row.names = 1, check.names = FALSE))
colnames(sampleData_all) <- c("condition", "type", "batch")
sampleData_all$batch <- as.factor(sampleData_all$batch)
sampleData_all$type <- as.factor(sampleData_all$type)
sampleData_all$condition <- as.factor(sampleData_all$condition)

# load gtf
gtf.rtl <- rtracklayer::import(gtf)
gtf.df <- as.data.frame(gtf.rtl)
gtf_gene <- droplevels(subset(gtf.df, type == "gene"))

## Combinations of conditions
comparison <- strsplit(cmp, ",")

## check combi
if (combi == "none") {
    combi <- ""
}

## readin counttable
countData_all <- as.matrix(read.table(gzfile(countfile), header = T, row.names = 1, check.names = FALSE))

# Check if names are consistent
if (!all(rownames(sampleData_all) %in% colnames(countData_all))) {
    stop("Count file does not correspond to the annotation file")
}

comparison_objs <- list()

WD <- getwd()
setwd(outdir)

for (contrast in comparison[[1]]) {
    contrast_name <- strsplit(contrast, ":")[[1]][1]
    contrast_groups <- strsplit(strsplit(contrast, ":")[[1]][2], "-vs-")
    print(paste("Comparing ", contrast_name, sep = ""))

    # determine contrast
    A <- unlist(strsplit(contrast_groups[[1]][1], "\\+"), use.names = FALSE)
    B <- unlist(strsplit(contrast_groups[[1]][2], "\\+"), use.names = FALSE)

    # subset Datasets for pairwise comparison
    countData <- cbind(countData_all[, grepl(paste("^", B, "_", sep = ""), colnames(countData_all))], countData_all[, grepl(paste("^", A, "_", sep = ""), colnames(countData_all))])
    sampleData <- droplevels(rbind(subset(sampleData_all, B == condition), subset(sampleData_all, A == condition)))

    ## Create design-table considering different types (paired, unpaired) and batches
    if (length(unique(subset(sampleData, A == condition)$type)) > 1 | length(unique(subset(sampleData, B == condition)$type)) > 1) {
        if (length(unique(subset(sampleData, A == condition)$batch)) > 1 | length(unique(subset(sampleData, B == condition)$batch)) > 1) {
            design <- ~ type + batch + condition
        } else {
            design <- ~ type + condition
        }
    } else {
        if (length(unique(subset(sampleData, A == condition)$batch)) > 1 | length(unique(subset(sampleData, B == condition)$batch)) > 1) {
            design <- ~ batch + condition
        } else {
            design <- ~condition
        }
    }
    print(design)

    # Normalize by spike in if available
    if (spike != "") {
        print("Spike-in used, data will be normalized to spike in separately")
        spike <- strsplit(spike, "=")[[1]][2]
        setwd(WD)
        ctrlgenes <- readLines(spike)
        setwd(outdir)

        counts_norm <- RUVg(newSeqExpressionSet(as.matrix(countData)), ctrlgenes, k = 1)
        countData <- countData %>% subset(!row.names(countData) %in% ctrlgenes) # removing spike-ins for standard analysis

        sampleData_norm <- cbind(sampleData, pData(counts_norm))
        design_norm <- as.formula(paste(deparse(design), colnames(pData(counts_norm))[1], sep = " + "))

        dds_norm <- DESeqDataSetFromMatrix(countData = counts(counts_norm), colData = sampleData_norm, design = design)

        # filter low counts
        keep_norm <- rowSums(counts(dds_norm)) >= 10
        dds_norm <- dds_norm[keep_norm, ]

        # drop unused samples
        dds_norm$condition <- droplevels(dds_norm$condition)

        # relevel to base condition B
        dds_norm$condition <- relevel(dds_norm$condition, ref = B[[1]])

        dds_norm <- DESeq(dds_norm, parallel = TRUE, BPPARAM = BPPARAM, betaPrior = FALSE)
        rld_norm <- rlogTransformation(dds_norm, blind = FALSE)
        vsd_norm <- varianceStabilizingTransformation(dds_norm, blind = FALSE)

        png(paste("Figures/DE", "DESEQ2", combi, contrast_name, "figure", "PCA_norm.png", sep = "_"))
        DESeq2::plotPCA(rld_norm, intgroup = c("condition")) + geom_text_repel(aes(label = name), arrow = arrow(length = unit(0.02, "npc")), box.padding = .5) # requires ggrepel
        # DESeq2::plotPCA(rld_norm, intgroup=c('condition')) + geom_text(aes(label = name), position = position_nudge(y = 2))
        dev.off()

        # We also write the normalized counts to file
        write.table(as.data.frame(assay(rld_norm)), gzfile(paste("Tables/DE", "DESEQ2", combi, contrast_name, "table", "rld_norm.tsv.gz", sep = "_")), sep = "\t", col.names = NA)
        write.table(as.data.frame(assay(vsd_norm)), gzfile(paste("Tables/DE", "DESEQ2", combi, contrast_name, "table", "vsd_norm.tsv.gz", sep = "_")), sep = "\t", col.names = NA)
    }

    # Create DESeqDataSet
    dds <- DESeqDataSetFromMatrix(countData = countData, colData = sampleData, design = design)

    # filter low counts
    keep <- rowSums(counts(dds)) >= 10
    dds <- dds[keep, ]

    # drop unused samples
    dds$condition <- droplevels(dds$condition)

    # relevel to base condition B
    dds$condition <- relevel(dds$condition, ref = B[[1]])

    # run for each pair of conditions
    dds <- DESeq(dds, parallel = TRUE, BPPARAM = BPPARAM, betaPrior = FALSE)
    print(resultsNames(dds))

    # Now we want to transform the raw discretely distributed counts so that we can do clustering. (Note: when you expect a large treatment effect you should actually set blind=FALSE (see https://bioconductor.org/packages/release/bioc/vignettes/DESeq2/inst/doc/DESeq2.html).

    rld <- rlogTransformation(dds, blind = FALSE)
    vsd <- varianceStabilizingTransformation(dds, blind = FALSE)

    png(paste("Figures/DE", "DESEQ2", combi, contrast_name, "figure", "PCA.png", sep = "_"))
    DESeq2::plotPCA(rld, intgroup = c("condition")) + geom_text_repel(aes(label = name), arrow = arrow(length = unit(0.02, "npc")), box.padding = .5) # requires ggrepel
    # DESeq2::plotPCA(rld, intgroup=c('condition')) + geom_text(aes(label = name), position = position_nudge(y = 2))
    dev.off()

    # We also write the normalized counts to file
    write.table(as.data.frame(assay(rld)), gzfile(paste("Tables/DE", "DESEQ2", combi, contrast_name, "table", "rld.tsv.gz", sep = "_")), sep = "\t", col.names = NA)
    write.table(as.data.frame(assay(vsd)), gzfile(paste("Tables/DE", "DESEQ2", combi, contrast_name, "table", "vsd.tsv.gz", sep = "_")), sep = "\t", col.names = NA)

    tryCatch({
        # initialize empty objects
        res <- ""
        resOrdered <- ""
        res <- results(dds, contrast = c("condition", A, B), parallel = TRUE, BPPARAM = BPPARAM)
        resn <- res
        res_shrink <- lfcShrink(dds = dds, coef = paste("condition", A, "vs", B, sep = "_"), res = res, type = "apeglm")

        # add comp object to list for image
        comparison_objs[[contrast_name]] <- res

        # sort and output
        resOrdered <- res_shrink[order(res_shrink$log2FoldChange), ]

        # # Add gene names  (check how gene_id col is named )
        resOrdered$Gene <- lapply(rownames(resOrdered), function(x) {
            get_gene_name(x, gtf_gene)
        })
        resOrdered$Gene_ID <- rownames(resOrdered)
        resOrdered <- resOrdered[, c(7, 6, 1, 2, 3, 4, 5)]
        resOrdered <- as.data.frame(apply(resOrdered, 2, as.character))

        # write the table to a tsv file
        write.table(as.data.frame(resOrdered), gzfile(paste("Tables/DE", "DESEQ2", combi, contrast_name, "table", "results.tsv.gz", sep = "_")), sep = "\t", row.names = FALSE, quote = F)

        # sort and output
        res <- resn[order(resn$log2FoldChange), ]

        res$Gene <- lapply(rownames(res), function(x) {
            get_gene_name(x, gtf_gene)
        })
        res$Gene_ID <- rownames(res)
        res <- res[, c(8, 7, 1, 2, 3, 5, 6)]
        res <- as.data.frame(apply(res, 2, as.character))

        write.table(as.data.frame(res), gzfile(paste("Tables/DE", "DESEQ2", combi, contrast_name, "table", "results_noshrink.tsv.gz", sep = "_")), sep = "\t", row.names = FALSE, quote = F)

        # plotMA
        png(paste("Figures/DE", "DESEQ2", combi, contrast_name, "figure", "MA.png", sep = "_"))
        DESeq2::plotMA(res_shrink)
        dev.off()

        if (spike != "") { # DE run for spike-in normalized data

            # initialize empty objects
            res <- ""
            resOrdered <- ""
            res <- results(dds_norm, contrast = c("condition", A, B), parallel = TRUE, BPPARAM = BPPARAM)
            resn <- res
            res_shrink <- lfcShrink(dds = dds_norm, coef = paste("condition", A, "vs", B, sep = "_"), res = res, type = "apeglm")

            # add comp object to list for image
            listname <- paste(contrast_name, "_norm", sep = "")
            comparison_objs[[listname]] <- res

            # sort and output
            resOrdered <- res_shrink[order(res_shrink$log2FoldChange), ]

            # # Add gene names  (check how gene_id col is named )
            resOrdered$Gene <- lapply(rownames(resOrdered), function(x) {
                get_gene_name(x, gtf_gene)
            })
            resOrdered$Gene_ID <- rownames(resOrdered)
            resOrdered <- resOrdered[, c(7, 6, 1, 2, 3, 4, 5)]
            resOrdered <- as.data.frame(apply(resOrdered, 2, as.character))

            # write the table to a tsv file
            write.table(as.data.frame(resOrdered), gzfile(paste("Tables/DE", "DESEQ2", combi, contrast_name, "table", "results_norm.tsv.gz", sep = "_")), sep = "\t", row.names = FALSE, quote = F)


            # sort and output
            res <- resn[order(resn$log2FoldChange), ]

            res$Gene <- lapply(rownames(res), function(x) {
                get_gene_name(x, gtf_gene)
            })
            res$Gene_ID <- rownames(res)
            res <- res[, c(7, 6, 1, 2, 3, 4, 5)]
            res <- as.data.frame(apply(res, 2, as.character))

            write.table(as.data.frame(res), gzfile(paste("Tables/DE", "DESEQ2", combi, contrast_name, "table", "results_norm_noshrink.tsv.gz", sep = "_")), sep = "\t", row.names = FALSE, quote = F)

            # plotMA
            png(paste("Figures/DE", "DESEQ2", combi, contrast_name, "figure", "MA_norm.png", sep = "_"))
            DESeq2::plotMA(res)
            dev.off()
        }

        # cleanup
        rm(res, resOrdered)
        print(paste("cleanup done for ", contrast_name, sep = ""))
    })
}

#### Now plot and print over-all comparisons

## Create design-table considering different types (paired, unpaired) and batches
design <- ~ 0 + condition
print(design)

# Create DESeqDataSet
dds <- DESeqDataSetFromMatrix(countData = countData_all, colData = sampleData_all, design = design)

# filter low counts
keep <- rowSums(counts(dds)) >= 10
dds <- dds[keep, ]

# run for each pair of conditions
dds <- DESeq(dds, parallel = TRUE, BPPARAM = BPPARAM, betaPrior = FALSE)

rld <- rlogTransformation(dds, blind = FALSE)
vsd <- varianceStabilizingTransformation(dds, blind = FALSE)

png(paste("Figures/DE", "DESEQ2", combi, "DataSet", "figure", "PCA.png", sep = "_"))
z <- plotPCA(rld, intgroup = c("condition"))
nudge <- position_nudge(y = 1)
z + geom_text(aes(label = name), position = nudge)
dev.off()

# We also write the normalized counts to file
write.table(as.data.frame(assay(rld)), gzfile(paste("Tables/DE", "DESEQ2", combi, "DataSet", "table", "rld.tsv.gz", sep = "_")), sep = "\t", col.names = NA)
write.table(as.data.frame(assay(vsd)), gzfile(paste("Tables/DE", "DESEQ2", combi, "DataSet", "table", "vsd.tsv.gz", sep = "_")), sep = "\t", col.names = NA)


# Here we choose blind so that the initial conditions setting does not influence the outcome, ie we want to see if the conditions cluster based purely on the individual datasets, in an unbiased way. According to the documentation, the rlogTransformation method that converts counts to log2 values is apparently better than the old varienceStabilisation method when the data size factors vary by large amounts.

par(mai = ifelse(1:4 <= 2, par("mai"), 0))
px <- counts(dds)[, 1] / sizeFactors(dds)[1]
ord <- order(px)
ord <- ord[px[ord] < 150]
ord <- ord[seq(1, length(ord), length = 50)]
last <- ord[length(ord)]
vstcol <- c("blue", "black")
png(paste("Figures/DE", "DESEQ2", combi, "DataSet", "figure", "VST-and-log2.png", sep = "_"))
matplot(px[ord], cbind(assay(vsd)[, 1], log2(px))[ord, ], type = "l", lty = 1, col = vstcol, xlab = "n", ylab = "f(n)")
legend("bottomright", legend = c(expression("variance stabilizing transformation"), expression(log[2](n / s[1]))), fill = vstcol)
dev.off()

##############################
library("RColorBrewer")
library("gplots")
select <- order(rowMeans(counts(dds, normalized = TRUE)), decreasing = TRUE)[1:30]
hmcol <- colorRampPalette(brewer.pal(9, "GnBu"))(100)
png(paste("Figures/DE", "DESEQ2", combi, "DataSet", "figure", "heatmap1.png", sep = "_"), width = 800, height = 750)
heatmap.2(counts(dds, normalized = TRUE)[select, ],
    col = hmcol,
    Rowv = FALSE, Colv = FALSE, scale = "none",
    dendrogram = "none", trace = "none", margin = c(12, 8)
)
dev.off()
png(paste("Figures/DE", "DESEQ2", combi, "DataSet", "figure", "heatmap2.png", sep = "_"), width = 800, height = 750)
heatmap.2(assay(rld)[select, ],
    col = hmcol,
    Rowv = FALSE, Colv = FALSE, scale = "none",
    dendrogram = "none", trace = "none", margin = c(12, 8)
)
dev.off()
png(paste("Figures/DE", "DESEQ2", combi, "DataSet", "figure", "heatmap3.png", sep = "_"), width = 800, height = 750)
heatmap.2(assay(vsd)[select, ],
    col = hmcol,
    Rowv = FALSE, Colv = FALSE, scale = "none",
    dendrogram = "none", trace = "none", margin = c(12, 8)
)
dev.off()

# The above shows heatmaps for 30 most highly expressed genes (not necessarily the biggest fold change). The data is of raw counts (left), regularized log transformation (center) and from variance stabilizing transformation (right) and you can clearly see the effect of the transformation has by shrinking the variance so that we don’t get the squish effect shown in the left hand graph.
##############################
# Now we calculate sample to sample distances so we can make a dendrogram to look at the clustering of samples.
distsRL <- dist(t(assay(rld)))
mat <- as.matrix(distsRL)
rownames(mat) <- colnames(mat) <- with(colData(dds), condition)
# updated in latest vignette (See comment by Michael Love)
# this line was incorrect
# heatmap.2(mat, trace='none', col = rev(hmcol), margin=c(16, 16))
# From the Apr 2015 vignette
hc <- hclust(distsRL)
png(paste("Figures/DE", "DESEQ2", combi, "DataSet", "figure", "heatmap-samplebysample.png", sep = "_"), width = 800, height = 800)
heatmap.2(mat,
    Rowv = as.dendrogram(hc),
    symm = TRUE, trace = "none",
    col = rev(hmcol), margin = c(13, 13)
)
dev.off()

##############################

save.image(file = paste("DE", "DESEQ2", combi, "SESSION.gz", sep = "_"), version = NULL, ascii = FALSE, compress = "gzip", safe = TRUE)

suppressPackageStartupMessages({
    require(dplyr)
    require(BiocParallel)
    require(edgeR)
    require(rtracklayer)
})

options(echo = TRUE)

## ARGS
args <- commandArgs(trailingOnly = TRUE)
anname <- args[1]
countfile <- args[2]
gtf <- args[3]
outdir <- args[4]
cmp <- args[5]
combi <- args[6]
availablecores <- as.integer(args[7])
print(args)

## FUNCS
libp <- paste0(gsub("/bin/conda", "/envs/monsda", Sys.getenv("CONDA_EXE")), "/share/MONSDA/scripts/lib/_lib.R")
source(libp)

### SCRIPT
print(paste("Will run EdgeR DAS with ", availablecores, " cores", sep = ""))

## set thread-usage
BPPARAM <- MulticoreParam(workers = availablecores)

# load gtf
gtf.rtl <- rtracklayer::import(gtf)
gtf.df <- as.data.frame(gtf.rtl)
gtf_gene <- droplevels(subset(gtf.df, type == "gene"))

## Annotation
sampleData_all <- as.data.frame(read.table(gzfile(anname), row.names = 1))
colnames(sampleData_all) <- c("condition", "type", "batch")
sampleData_all$condition <- as.factor(sampleData_all$condition)
sampleData_all$batch <- as.factor(sampleData_all$batch)
sampleData_all$type <- as.factor(sampleData_all$type)
samples <- rownames(sampleData_all)

## Combinations of conditions
comparisons <- strsplit(cmp, ",")

## check combi
if (combi == "none") {
    combi <- ""
}

## readin counttable
countData_all <- read.table(countfile, header = TRUE, row.names = 1)

# Check if names are consistent
if (!all(rownames(sampleData_all) %in% colnames(countData_all))) {
    stop("Count file does not correspond to the annotation file")
}

comparison_objs <- list()

WD <- getwd()
setwd(outdir)

## Analyze according to comparison groups
for (compare in comparisons[[1]]) {
    contrast_name <- strsplit(compare, ":")[[1]][1]
    contrast_groups <- strsplit(strsplit(compare, ":")[[1]][2], "-vs-")

    print(paste("Comparing ", contrast_name, sep = ""))

    # determine contrast
    A <- unlist(strsplit(contrast_groups[[1]][1], "\\+"), use.names = FALSE)
    B <- unlist(strsplit(contrast_groups[[1]][2], "\\+"), use.names = FALSE)

    # subset Datasets for pairwise comparison
    countData <- cbind(countData_all[, grepl(paste("^", B, "_", sep = ""), colnames(countData_all))], countData_all[, grepl(paste("^", A, "_", sep = ""), colnames(countData_all))])
    sampleData <- droplevels(rbind(subset(sampleData_all, B == condition), subset(sampleData_all, A == condition)))
    sampleData$condition <- relevel(sampleData$condition, ref = B)
    samples <- rownames(sampleData)
    ## name types and levels for design
    bl <- sapply("batch", paste0, levels(sampleData$batch)[1:length(levels(sampleData$batch)) - 1])
    tl <- sapply("type", paste0, levels(sampleData$type)[1:length(levels(sampleData$type)) - 1])

    ## Create design-table considering different types (paired, unpaired) and batches
    if (length(unique(subset(sampleData, A == condition)$type)) > 1 | length(unique(subset(sampleData, B == condition)$type)) > 1) {
        if (length(unique(subset(sampleData, A == condition)$batch)) > 1 | length(unique(subset(sampleData, B == condition)$batch)) > 1) {
            des <- ~ type + batch + condition
            design <- model.matrix(des, data = sampleData)
            # colnames(design) <- c(levels(sampleData$condition), tl, bl)
        } else {
            des <- ~ type + condition
            design <- model.matrix(des, data = sampleData)
            # colnames(design) <- c(levels(condition), tl)
        }
    } else {
        if (length(unique(subset(sampleData, A == condition)$batch)) > 1 | length(unique(subset(sampleData, B == condition)$batch)) > 1) {
            des <- ~ batch + condition
            design <- model.matrix(des, data = sampleData)
            # colnames(design) <- c(levels(sampleData$condition), bl)
        } else {
            des <- ~condition
            design <- model.matrix(des, data = sampleData)
            # colnames(design) <- levels(sampleData$condition)
        }
    }
    print(design)

    ## get genes names out
    genes <- rownames(countData)

    ## get genes and exon names out
    splitted <- strsplit(rownames(countData), ":")
    exons <- sapply(splitted, "[[", 2)
    genesrle <- sapply(splitted, "[[", 1)

    dge <- DGEList(counts = countData, group = sampleData$condition, samples = samples, genes = genesrle)

    ## Addd exons to dge
    dge$genes$exons <- exons

    ## filter low counts
    keep <- filterByExpr(dge)
    dge <- dge[keep, , keep.lib.sizes = FALSE]

    # relevel to base condition B
    dge$samples$group <- relevel(dge$samples$group, ref = B[[1]])

    ## normalize with TMM
    dge <- calcNormFactors(dge, method = "TMM", BPPARAM = BPPARAM)

    ## create file normalized table
    tmm <- as.data.frame(cpm(dge))
    colnames(tmm) <- t(dge$samples$samples)
    tmm$ID <- dge$genes$genes
    tmm <- tmm[c(ncol(tmm), 1:ncol(tmm) - 1)]

    tmm.genes <- tmm
    tmm.genes$Gene <- lapply(tmm.genes$ID, function(x) {
        get_exon_name(x, gtf.df)
    })
    tmm.genes <- as.data.frame(apply(tmm.genes, 2, as.character))
    write.table(as.data.frame(tmm.genes), gzfile(paste("Tables/DAS", "EDGER", combi, contrast_name, "DataSet", "table", "Normalized.tsv.gz", sep = "_")), sep = "\t", quote = F, row.names = FALSE)

    ## create file MDS-plot with and without sumarized replicates
    out <- paste("Figures/DAS", "EDGER", combi, contrast_name, "DataSet", "figure", "MDS.png", sep = "_")
    png(out)
    plotMDS(dge, col = as.numeric(dge$samples$group), cex = 1)
    dev.off()

    ## estimate Dispersion
    dge <- estimateDisp(dge, design, robust = TRUE)

    ## create file BCV-plot - visualizing estimated dispersions
    out <- paste("Figures/DAS", "EDGER", combi, contrast_name, "DataSet", "figure", "BCV.png", sep = "_")
    png(out)
    plotBCV(dge)
    dev.off()

    ## fitting a quasi-likelihood negative binomial generalized log-linear model to counts
    fit <- glmQLFit(dge, design, robust = TRUE)

    ## create file quasi-likelihood-dispersion-plot
    out <- paste("Figures/DAS", "EDGER", combi, contrast_name, "DataSet", "figure", "QLDisp.png", sep = "_")
    png(out)
    plotQLDisp(fit)
    dev.off()

    tryCatch({
        # # determine contrast
        # A <- strsplit(contrast_groups[[1]][1], "\\+")
        # B <- strsplit(contrast_groups[[1]][2], "\\+")
        # minus <- 1/length(A[[1]])*(-1)
        # plus <- 1/length(B[[1]])
        # contrast <- cbind(integer(dim(design)[2]), colnames(design))
        # for(i in A[[1]]){
        #   contrast[which(contrast[,2]==i)]<- minus
        # }
        # for(i in B[[1]]){
        #   contrast[which(contrast[,2]==i)]<- plus
        # }
        # contrast <- as.numeric(contrast[,1])

        # create files topSpliced by gene, simes and exon method
        # sp <- diffSpliceDGE(fit, contrast=contrast, geneid="genes", exonid="exons", verbose=FALSE)
        sp <- diffSpliceDGE(fit, geneid = "genes", exonid = "exons", verbose = FALSE)

        # add comp object to list for image
        comparison_objs <- append(comparison_objs, sp)

        tops <- topSpliceDGE(sp, test = "gene", n = length(fit$counts))
        tops$Gene <- lapply(strsplit(rownames(tops), split = ":")[[1]][1], function(x) {
            get_gene_name(x, gtf.df)
        })
        tops$Gene_ID <- rownames(tops)
        tops <- tops[, c(7, 6, 3, 4, 5, 2)]
        tops <- as.data.frame(apply(tops, 2, as.character))
        write.table(as.data.frame(tops), gzfile(paste("Tables/DAS", "EDGER", combi, contrast_name, "table", "resultsGeneTest.tsv.gz", sep = "_")), sep = "\t", quote = F, row.names = FALSE)

        tops <- topSpliceDGE(sp, test = "simes", n = length(fit$counts))
        tops$Gene <- lapply(strsplit(rownames(tops), split = ":")[[1]][1], function(x) {
            get_gene_name(x, gtf_gene)
        })
        tops$Gene_ID <- rownames(tops)
        tops <- tops[, c(6, 5, 2, 3, 4)]
        tops <- as.data.frame(apply(tops, 2, as.character))
        write.table(as.data.frame(tops), gzfile(paste("Tables/DAS", "EDGER", combi, contrast_name, "table", "resultsSimesTest.tsv.gz", sep = "_")), sep = "\t", quote = F, row.names = FALSE)

        tops <- topSpliceDGE(sp, test = "exon", n = length(fit$counts))
        tops$Gene <- lapply(strsplit(rownames(tops), split = ":")[[1]][1], function(x) {
            get_gene_name(x, gtf_gene)
        })
        tops$Gene_ID <- rownames(tops)
        tops <- tops[, c(8, 7, 4, 5, 6, 2, 3)]
        tops <- as.data.frame(apply(tops, 2, as.character))
        write.table(as.data.frame(tops), gzfile(paste("Tables/DAS", "EDGER", combi, contrast_name, "table", "resultsDiffSpliceExonTest.tsv.gz", sep = "_")), sep = "\t", quote = F, row.names = FALSE)

        # create files diffSplicePlots
        tops <- topSpliceDGE(sp, test = "simes", n = length(fit$counts))
        figures <- data.frame("geneID" = character(), "exonID" = character(), "file" = character(), stringsAsFactors = FALSE)
        sigs <- which(tops$P.Value < 0.05)

        limit <- 100
        counter <- 1
        message("create splice plots")
        for (gene in sigs) {
            if (counter > limit) {
                break
            }

            name1 <- paste("Figures/DAS", "EDGER", combi, contrast_name, tops$genes[gene], "figure", "transcripts.png", sep = "_")
            png(name1)
            print(plotSpliceDGE(sp, geneid = tops$genes[gene], genecol = "genes"))
            dev.off()
            figures[counter, ] <- c(rownames(tops)[gene], tops$genes[gene], paste(outdir, name1, sep = "/"))

            counter <- counter + 1
        }
        write.table(figures, paste("Figures/DAS", "EDGER", combi, contrast_name, "list", "topSpliceSimes.tsv", sep = "_"), sep = "\t", quote = F, row.names = FALSE, col.names = TRUE)

        # cleanup
        rm(lrt, tops, BPPARAM)
        print(paste("cleanup done for ", contrast_name, sep = ""))
    })
}

## Create design-table considering different types (paired, unpaired) and batches
des <- ~ 0 + condition
design <- model.matrix(des, data = sampleData_all)
colnames(design) <- levels(sampleData_all$condition)
print(design)
## get genes names out
genes <- rownames(countData_all)
samples <- rownames(sampleData_all)

## get genes and exon names out
splitted <- strsplit(rownames(countData), ":")
exons <- sapply(splitted, "[[", 2)
genesrle <- sapply(splitted, "[[", 1)

dge <- DGEList(counts = countData_all, group = sampleData_all$condition, samples = samples, genes = genesrle)

## Addd exons to dge
dge$genes$exons <- exons

## filter low counts
keep <- filterByExpr(dge)
dge <- dge[keep, , keep.lib.sizes = FALSE]

## normalize with TMM
dge <- calcNormFactors(dge, method = "TMM", BPPARAM = BPPARAM)

## create file normalized table
tmm <- as.data.frame(cpm(dge))
colnames(tmm) <- t(dge$samples$samples)
tmm$ID <- dge$genes$genes
tmm <- tmm[c(ncol(tmm), 1:ncol(tmm) - 1)]

tmm.genes <- tmm
tmm.genes$Gene <- lapply(tmm.genes$ID, function(x) {
    get_gene_name(x, gtf_gene)
})
tmm.genes <- as.data.frame(apply(tmm.genes, 2, as.character))
write.table(as.data.frame(tmm.genes), gzfile(paste("Tables/DAS", "EDGER", combi, "DataSet", "table", "AllConditionsNormalized.tsv.gz", sep = "_")), sep = "\t", quote = F, row.names = FALSE)

## create file MDS-plot with and without sumarized replicates
out <- paste("Figures/DAS", "EDGER", combi, "DataSet", "figure", "AllConditionsMDS.png", sep = "_")
png(out)
plotMDS(dge, col = as.numeric(dge$samples$group), cex = 1)
dev.off()

## estimate Dispersion
dge <- estimateDisp(dge, design, robust = TRUE)

## create file BCV-plot - visualizing estimated dispersions
out <- paste("Figures/DAS", "EDGER", combi, "DataSet", "figure", "AllConditionsBCV.png", sep = "_")
png(out)
plotBCV(dge)
dev.off()

## fitting a quasi-likelihood negative binomial generalized log-linear model to counts
fit <- glmQLFit(dge, design, robust = TRUE)

## create file quasi-likelihood-dispersion-plot
out <- paste("Figures/DAS", "EDGER", combi, "DataSet", "figure", "AllConditionsQLDisp.png", sep = "_")
png(out)
plotQLDisp(fit)
dev.off()


save.image(file = paste("DAS_EDGER", combi, "SESSION.gz", sep = "_"), version = NULL, ascii = FALSE, compress = "gzip", safe = TRUE)

#source("http://bioconductor.org/biocLite.R")
#biocLite("topGO")
#if (!requireNamespace("BiocManager", quietly=TRUE))
#    install.packages("BiocManager")
#BiocManager::install("topGO")

suppressPackageStartupMessages({
    require(topGO)
    require(Rgraphviz)
})

#define notin
`%notin%` = Negate(`%in%`)

args <- commandArgs(TRUE)
background <- args[1]
test <- args[2]
GOs <- args[3]

#run GO
geneID2GO <- readMappings(GOs, sep = "\t", IDsep = ",")
expressedGenes <- read.table(background,sep="\t")
Genes <- read.table(test,sep="\t")
GenesOI <- Genes$V1
geneList <- factor(as.integer(expressedGenes$V1 %in% GenesOI))
names(geneList) <- expressedGenes$V1

GOdata <- new("topGOdata",
              ontology = "MF",
              allGenes = geneList,
              geneSel = GenesOI,
              annot = annFUN.gene2GO,  # the new annotation function
              gene2GO = geneID2GO)    ## the gene ID to GOs dataset

test.stat <- new("classicCount", testStatistic = GOFisherTest, name = "Fisher test")
resultFisher <- getSigGroups(GOdata, test.stat)
pvalFis <- score(resultFisher)
resultWeight <- getSigGroups(GOdata, test.stat)
pvalWeight <- score(resultWeight, whichGO = names(pvalFis))
cor(pvalFis, pvalWeight)
geneData(resultWeight)
allRes <- GenTable(GOdata, classic = resultFisher, weight = resultWeight, orderBy = "weight", ranksOf = "classic", topNodes = 20)
write.table(allRes, file = paste("TopGO_MF",test,sep="_"), append = FALSE, quote = TRUE, sep = "\t", eol = "\n", na = "NA", dec = ".", row.names = TRUE, col.names = TRUE, qmethod = "double")
printGraph(GOdata, resultFisher, firstSigNodes = 10, fn.prefix = paste("TopGO_MFGraph",test,sep="_"), useInfo = "all", pdfSW = TRUE)

GOdata <- new("topGOdata",
              ontology = "BP",
              allGenes = geneList,
              geneSel = GenesOI,
              annot = annFUN.gene2GO,  # the new annotation function
              gene2GO = geneID2GO)    ## the gene ID to GOs dataset

test.stat <- new("classicCount", testStatistic = GOFisherTest, name = "Fisher test")
resultFisher <- getSigGroups(GOdata, test.stat)
pvalFis <- score(resultFisher)
resultWeight <- getSigGroups(GOdata, test.stat)
pvalWeight <- score(resultWeight, whichGO = names(pvalFis))
cor(pvalFis, pvalWeight)
geneData(resultWeight)
allRes <- GenTable(GOdata, classic = resultFisher, weight = resultWeight, orderBy = "weight", ranksOf = "classic", topNodes = 20)
write.table(allRes, file = paste("TopGO_BP",test,sep="_"), append = FALSE, quote = TRUE, sep = "\t", eol = "\n", na = "NA", dec = ".", row.names = TRUE, col.names = TRUE, qmethod = "double")
printGraph(GOdata, resultFisher, firstSigNodes = 10, fn.prefix = paste("TopGO_BPGraph",test,sep="_"), useInfo = "all", pdfSW = TRUE)

## Modified from https://github.com/vivekbhr/Subread_to_DEXSeq/blob/master/load_SubreadOutput.R
## Load Fcount output from : DEXSeq_after_Fcount.R into DEXSeq
## Copyright 2015 Vivek Bhardwaj (bhardwaj@ie-freiburg.mpg.de). Licence: GPLv3.

suppressPackageStartupMessages({
    require(dplyr)
    require(BiocParallel)
    require(DEXSeq)
    require(rtracklayer)
})

options(echo = TRUE)

## define notin
`%notin%` <- Negate(`%in%`)

## ARGS
args <- commandArgs(trailingOnly = TRUE)

anname <- args[1]
countfile <- args[2]
gtf <- args[3]
flatanno <- args[4]
outdir <- args[5]
cmp <- args[6]
combi <- args[7]
availablecores <- as.integer(args[8])
print(args)

## FUNCS
libp <- paste0(gsub("/bin/conda", "/envs/monsda", Sys.getenv("CONDA_EXE")), "/share/MONSDA/scripts/lib/_lib.R")
source(libp)

### SCRIPT
# load gtf
gtf.rtl <- rtracklayer::import(gtf)
gtf.df <- as.data.frame(gtf.rtl)

BPPARAM <- MulticoreParam(workers = availablecores)

## Annotation
sampleData <- as.data.frame(read.table(gzfile(anname), row.names = 1))
colnames(sampleData) <- c("condition", "type", "batch")
# head(sampleData)
comparisons <- strsplit(cmp, ",")
print(paste("Will analyze conditions ", comparisons, sep = ""))

## check combi
if (combi == "none") {
    combi <- ""
}

## Create design-table considering different types (paired, unpaired) and batches
if (length(levels(sampleData$type)) > 1) {
    if (length(levels(sampleData$batch)) > 1) {
        full <- ~ sample + exon + type:exon + batch:exon + condition:exon
        reduced <- ~ sample + exon + type:exon + batch:exon
    } else {
        full <- ~ sample + exon + type:exon + condition:exon
        reduced <- ~ sample + exon + type:exon
    }
} else {
    if (length(levels(sampleData$batch)) > 1) {
        full <- ~ sample + exon + batch:exon + condition:exon
        reduced <- ~ sample + exon + batch:exon
    } else {
        full <- ~ sample + exon + condition:exon
        reduced <- ~ sample + exon
    }
}

print(paste("FITTING DESIGN: ", full, reduced, sep = ""))

## Read Fcount output and convert to dxd
DEXSeqDataSetFromFeatureCounts <- function(countfile, sampleData, design = design, flattenedfile = NULL) {
    ##  Take a fcount file and convert it to dcounts for dexseq
    print("Reading and adding Exon IDs for DEXSeq")

    read.table(countfile, skip = 2) %>% dplyr::arrange(V1, V3, V4) -> dcounts
    colnames(dcounts) <- c("GeneID", rownames(sampleData))
    id <- as.character(dcounts[, 1])
    n <- id
    split(n, id) <- lapply(split(n, id), seq_along)
    rownames(dcounts) <- sprintf("%s%s%03.f", id, ":E", as.numeric(n))
    dcounts <- dcounts[, 2:ncol(dcounts)]

    dcounts <- dcounts[substr(rownames(dcounts), 1, 1) != "_", ] # remove _ from beginnning of gene name
    ## filter low counts
    keep <- rowSums(dcounts) >= 10
    dcounts <- dcounts[keep, ]

    ## get genes and exon names out
    splitted <- strsplit(rownames(dcounts), ":")
    exons <- sapply(splitted, "[[", 2)
    genesrle <- sapply(splitted, "[[", 1)

    ## parse the flattened file
    if (!is.null(flattenedfile)) {
        aggregates <- read.delim(flattenedfile, stringsAsFactors = FALSE, header = FALSE)
        colnames(aggregates) <- c("chr", "source", "class", "start", "end", "ex", "strand", "ex2", "attr")
        aggregates$strand <- gsub("\\.", "*", aggregates$strand)
        aggregates <- aggregates[which(aggregates$class == "exonic_part"), ]
        aggregates$attr <- gsub("\"|=|;", "", aggregates$attr)
        aggregates$gene_id <- sub(".*gene_id\\s(\\S+).*", "\\1", aggregates$attr)
        # trim the gene_ids to 255 chars in order to match with featurecounts
        longIDs <- sum(nchar(unique(aggregates$gene_id)) > 255)
        warning(paste0(longIDs, " aggregate geneIDs were found truncated in featureCounts output"), call. = FALSE)
        aggregates$gene_id <- substr(aggregates$gene_id, 1, 255)

        transcripts <- gsub(".*transcripts\\s(\\S+).*", "\\1", aggregates$attr)
        transcripts <- strsplit(transcripts, "\\+")
        exonids <- gsub(".*exonic_part_number\\s(\\S+).*", "\\1", aggregates$attr)
        exoninfo <- GRanges(as.character(aggregates$chr), IRanges(start = aggregates$start, end = aggregates$end), strand = aggregates$strand)
        names(exoninfo) <- paste(aggregates$gene_id, exonids, sep = ":E")

        names(transcripts) <- names(exoninfo)
        if (!all(rownames(dcounts) %in% names(exoninfo))) {
            print(head(rownames(dcounts)))
            print(head(names(exoninfo)))
            stop("Count files do not correspond to the flattened annotation file")
        }
        matching <- match(rownames(dcounts), names(exoninfo))
        stopifnot(all(names(exoninfo[matching]) == rownames(dcounts)))
        stopifnot(all(names(transcripts[matching]) == rownames(dcounts)))
        dxd <- DEXSeqDataSet(dcounts, sampleData, design, exons, genesrle, exoninfo[matching], transcripts[matching])
        return(dxd)
    } else {
        dxd <- DEXSeqDataSet(dcounts, sampleData, design, exons, genesrle)
        return(dxd)
    }
}

### MAIN ###
# read in count table and normalize

dxd <- DEXSeqDataSetFromFeatureCounts(countfile, sampleData, design = full, flattenedfile = flatanno)

comparison_objs <- list()

setwd(outdir)
print(paste("Will run DEXSeq with ", availablecores, " cores", sep = ""))

for (contrast in comparisons[[1]]) {
    contrast_name <- strsplit(contrast, ":")[[1]][1]
    contrast_groups <- strsplit(strsplit(contrast, ":")[[1]][2], "-vs-")

    print(paste("Comparing ", contrast_name, sep = ""))

    # initialize empty objects
    dxdpair <- ""
    dxr1 <- ""

    tryCatch({
        # determine contrast
        A <- unlist(strsplit(contrast_groups[[1]][1], "\\+"), use.names = FALSE)
        B <- unlist(strsplit(contrast_groups[[1]][2], "\\+"), use.names = FALSE)
        C <- c(A, B)

        dxdpair <- dxd[, dxd$condition %in% C]

        dxdpair <- estimateSizeFactors(dxdpair)
        dxdpair <- estimateDispersions(dxdpair, BPPARAM = BPPARAM)

        png(paste("Figures/DEU", "DEXSEQ", combi, contrast_name, "figure", "DispEsts.png", sep = "_"))
        plotDispEsts(dxdpair)
        dev.off()

        dxdpair <- testForDEU(dxdpair, reducedModel = reduced, fullModel = full, BPPARAM = BPPARAM)

        dxdpair <- estimateExonFoldChanges(dxdpair, fitExpToVar = "condition", BPPARAM = BPPARAM)

        dxr1 <- DEXSeqResults(dxdpair)

        comparison_objs[[contrast_name]] <- dxr1

        png(paste("Figures/DEU", "DEXSEQ", combi, contrast_name, "figure", "plotMA.png", sep = "_"))
        print(plotMA(dxr1, cex = 0.8))
        dev.off()

        toprint <- as.data.frame(dxr1)
        toprint$transcripts <- vapply(toprint$transcripts, paste, collapse = ", ", character(1L))
        write.table(toprint, gzfile(paste("Tables/DEU", "DEXSEQ", combi, contrast_name, "table", "results.tsv.gz", sep = "_")), sep = "\t", row.names = FALSE, quote = F)


        htmlout <- paste("DEXSeq_", combi, "_", contrast_name, ".html", sep = "")
        pathout <- paste("DEXSeqReport", combi, contrast_name, sep = "_")
        check <- as.character(unique(dxr1$groupID[which(dxr1$padj < 0.1)]))
        if (length(check) > 0) {
            DEXSeqHTML(dxr1, FDR = 0.1, color = c("#FF000080", "#0000FF80"), path = pathout, file = htmlout, BPPARAM = BPPARAM)
        } else {
            print("There are no significant results in the test... nothing to report")
            dir.create(pathout, showWarnings = FALSE)
            cat(NULL, file = paste(pathout, htmlout, sep = .Platform$file.sep))
        }

        figures <- data.frame("geneID" = character(), "dxr1ID" = character(), "file" = character(), stringsAsFactors = FALSE)
        sigs <- as.data.frame(which(dxr1$padj < 0.01))
        colnames(sigs) <- c("id")
        sigs$padj <- dxr1$padj[sigs$id]
        sigs <- sigs$id[order(sigs$padj)]
        limit <- 100
        counter <- 1
        message("create transcripts plots")
        for (gene in sigs) {
            if (counter > limit) {
                break
            }
            name1 <- paste("Figures/DEU", "DEXSEQ", combi, contrast_name, counter, "figure", "transcripts.png", sep = "_")
            png(name1, height = 1000, width = 1000)
            print(plotDEXSeq(dxr1, dxr1$groupID[gene], legend = TRUE, cex.axis = 1.2, cex = 1.3, lwd = 2))
            dev.off()
            figures[counter, ] <- c(dxr1$groupID[gene], as.character(gene), paste(outdir, name1, sep = "/"))
            # figures <- rbind(figures, c(as.character(gene), dxr1$groupID[gene], paste(outdir,name1, sep="/")))

            counter <- counter + 1
        }
        write.table(figures, paste("Figures/DEU", "DEXSEQ", combi, contrast_name, "list", "sigGroupsFigures.tsv", sep = "_"), sep = "\t", quote = F, row.names = FALSE, col.names = TRUE)

        # cleanup
        rm(dxdpair, dxr1, toprint)
        print(paste("cleanup done for ", contrast_name, sep = ""))
    })
}

save.image(file = paste("DEU_DEXSEQ", combi, "SESSION.gz", sep = "_"), version = NULL, ascii = FALSE, compress = "gzip", safe = TRUE)

#!/bin/env bash
COND=$1
SOURCE=$2
PATTERN=$3
SAMPLES=$4

cut -d$'\t' -f1 L12270_09_WT_d4_1_2_IN_R1_mapped_sorted.transcript_counts > tmp_counts

for i in *$COND\_*$SOURCE\_*$PATTERN\.transcript_counts;do
	echo $i
	join -1 1 -2 1 <(sort -k1,1d tmp_counts) <(sort -k1,1d $i|cut -d$'\t' -f1,2,3) > COUNTS_$COND\_$SOURCE && cp -f COUNTS_$COND\_$SOURCE tmp_counts
done
rm -f tmp_counts

awk 'BEGIN{FS=" ";OFS=FS}{s=1;t=0;for(i=2;i<=NF;i+=2){if($i >=1){t+=$i;s++}} print $1,t/s;t=0;s=1}' COUNTS_$COND\_$SOURCE |sort -k1,1d > $SOURCE\_$COND\_$PATTERN\.transcript.counts

#join -1 1 -2 1 <(sort -k1,1d Gene_sum_bfx656.hg38.e81) <(sort -k1,1d COUNTS/Featurecounter/bfx656/Gene_sum_mapped_sorted_unique.counts) > Compare_D_L_uni
#join -1 1 -2 1 <(sort -k1,1d Gene_sum_bfx656.hg38.e81) <(sort -k1,1d COUNTS/Featurecounter/bfx656/Gene_sum_mapped_sortedall) > Compare_D_L

#bash ../../../Workflows/scripts/Shells/MergeExpression_RNAcounter.sh KO_d4 IP mapped_sorted 3
#bash ../../../Workflows/scripts/Shells/MergeExpression_RNAcounter.sh KO_d0 IP mapped_sorted 3
#bash ../../../Workflows/scripts/Shells/MergeExpression_RNAcounter.sh WT_d4 IP mapped_sorted 3
#bash ../../../Workflows/scripts/Shells/MergeExpression_RNAcounter.sh WT_d0 IP mapped_sorted 3
#bash ../../../Workflows/scripts/Shells/MergeExpression_RNAcounter.sh WT_d0 IN mapped_sorted 3
#bash ../../../Workflows/scripts/Shells/MergeExpression_RNAcounter.sh WT_d4 IN mapped_sorted 3
#bash ../../../Workflows/scripts/Shells/MergeExpression_RNAcounter.sh KO_d4 IN mapped_sorted 3
#bash ../../../Workflows/scripts/Shells/MergeExpression_RNAcounter.sh KO_d0 IN mapped_sorted 3

#!/bin/env bash
PATTERN=$1

for i in *$PATTERN;do
	echo $i
    grep -v '^#' $i|grep -v "^Gene"|cut -d$'\t' -f1,7 > ToJoin_$i
done

cut -d$'\t' -f1 ToJoin_L12270_09_WT_d4_1_2_IN_R1_mapped_sorted.counts > tmp_counts

for i in ToJoin_*$PATTERN;do
	echo $i
	join -1 1 -2 1 <(sort -k1,1d tmp_counts) <(sort -k1,1d $i) > COUNTS_$PATTERN && cp -f COUNTS_$PATTERN tmp_counts
done
rm -f tmp_counts

awk 'BEGIN{FS=" ";OFS=FS}{t=0;for(i=2;i<=NF;i++){t+=$i} print $1,t;t=0}' COUNTS_$PATTERN |sort -k1,1d > Gene_sum_$PATTERN

#join -1 1 -2 1 <(sort -k1,1d Gene_sum_bfx656.hg38.e81) <(sort -k1,1d COUNTS/Featurecounter/bfx656/Gene_sum_mapped_sorted_unique.counts) > Compare_D_L_uni
#join -1 1 -2 1 <(sort -k1,1d Gene_sum_bfx656.hg38.e81) <(sort -k1,1d COUNTS/Featurecounter/bfx656/Gene_sum_mapped_sortedall) > Compare_D_L

#!/usr/bin/env bash

inf=$1

if [[ -s $inf ]]
then
	if [[ "$inf" == *.gz* ]]	   
	then
		filename="${inf%.*}"
		zcat $inf > $filename && samtools faidx $filename && rm -f $filename
	else
		samtools faidx $inf
	fi
else
	touch $inf.fai
fi

qsub -t 1-3419 bulk_qsub_self_rnaplex.sh /scr/k70san/fall/RINTERwahn/PARIS/Annotated/Beds/SplitFasta/ /scr/k70san/fall/RINTERwahn/PARIS/Annotated/Beds/PlFold_Indexed/ /scr/k70san/fall/RINTERwahn/PARIS/PlexOut/

#!/bin/env bash
COND=$1
SOURCE=$2
PATTERN=$3
SAMPLES=$4

#cut -d$'\t' -f1 L12270_09_WT_d4_1_2_IN_R1_mapped_sorted.transcript_counts > tmp_counts

for i in *$COND\_*$SOURCE\_*$PATTERN\_unique/genes.fpkm_tracking;do
	echo $i
	tail -n+2 $i|cut -d$'\t' -f1,5,10  >>  GENECOUNTS_$COND\_$SOURCE\_tmp
done

#env sa=$SAMPLES perl -lan -F'\t' -e 'BEGIN{%exp=()}; $exp{$F[0]}+=$F[1]; END{foreach $key(keys %exp){print $key,"\t",$exp{$key}/$ENV{sa}}}' COUNTS_$COND\_$SOURCE\_tmp |sort -k1,1d > COUNTS_$COND\_$SOURCE.transcript.fpkm

#rm -f COUNTS_$COND\_$SOURCE\_tmp

#join -1 1 -2 1 <(sort -k1,1d Gene_sum_bfx656.hg38.e81) <(sort -k1,1d COUNTS/Featurecounter/bfx656/Gene_sum_mapped_sorted_unique.counts) > Compare_D_L_uni
#join -1 1 -2 1 <(sort -k1,1d Gene_sum_bfx656.hg38.e81) <(sort -k1,1d COUNTS/Featurecounter/bfx656/Gene_sum_mapped_sortedall) > Compare_D_L

#bash ../../../Workflows/scripts/Shells/MergeExpression_Cufflinks.sh KO_d4 IP R1 3
#bash ../../../Workflows/scripts/Shells/MergeExpression_Cufflinks.sh KO_d0 IP R1 3
#bash ../../../Workflows/scripts/Shells/MergeExpression_Cufflinks.sh WT_d4 IP R1 3
#bash ../../../Workflows/scripts/Shells/MergeExpression_Cufflinks.sh WT_d0 IP R1 3
#bash ../../../Workflows/scripts/Shells/MergeExpression_Cufflinks.sh WT_d0 IN R1 3
#bash ../../../Workflows/scripts/Shells/MergeExpression_Cufflinks.sh WT_d4 IN R1 3
#bash ../../../Workflows/scripts/Shells/MergeExpression_Cufflinks.sh KO_d4 IN R1 3
#bash ../../../Workflows/scripts/Shells/MergeExpression_Cufflinks.sh KO_d0 IN R1 3

#!/bin/bash
#iabulk_rnaplex args: path_fasta_directory fst_fasta_index snd_fasta_index path_accessibility_directory path_output_directory
echo "iabulk_rnaplex $1 $2 $3 $4 $5";
#set l to length of shorter seq
#RNAplfold only up to u=13, so l > 13 does not make any sense
#SEQLENGTH1=$((`tail -n 1 ${3}SplitFasta${1}.fa | wc -m`-1)); 
#SEQLENGTH2=$((`tail -n 1 ${3}SplitFasta${2}.fa | wc -m`-1));
#LENGTH=$((SEQLENGTH1 < SEQLENGTH2 ? SEQLENGTH1 : SEQLENGTH2));
LENGTH=13;
#if [ $LENGTH -lt 40 ];
#then
  gunzip -c ${4}${1}_openen.gz > ${4}${1}_openen && RNAplex -l $LENGTH -q  ${3}SplitFasta${1}.fa -t ${3}SplitFasta${2}.fa -a $4 > $5$2.plex && rm -f ${4}${1}_openen
#else
#  RNAplex -l 40 -q ${3}SplitFasta${1}.fa -t ${3}SplitFasta${2}.fa -a $4 > $5$2.plex
#fi

#!/bin/bash

file=$1 ### Name of the sam file you want to convert
ref=$2  ### Path to reference genome fasta file
bins=$3
out=$4
threads=$5

echo "running samtools view -bT $ref -o $out --threads $threads $file"

if [ ! -f $out ];then
        echo "$out not found, creating new"
        zcat $file|samtools view -bT $ref -o $out --threads $threads -
fi
if [ ! -f $out".bai" ];then
       echo "$out.bai not found, creating new"
        samtools index $out
fi

#!/usr/bin/env bash

in=$1
out=$2

if [ ! -f $out ]; then
	echo -e "SAMPLE\ttRNA\tCount" > $out
fi

fn=${in#*/}

zgrep -w CCA $in | perl -sae 'BEGIN{$c={}}{if($F[1] eq "seq"){@trnas=split(",",$F[6]);foreach $rna (@trnas){$c->{$rna}+=$F[3]}}}END{foreach $rna (keys %{$c}){print "$e\t$rna\t$c->{$rna}\n"}}' -- -e=$fn >> $out

#awk -v e="$a" 'BEGIN{FS="\t";OFS="";c=0}{c+=$3}END{if(e != "A"){print c,"\t"}else{print c}}' >> $out

#!/bin/bash

in=$1
out=$2
threads=$3
bwa="${4:-}"

if [[ "$1" == *.gz* ]]
then
    samtools view -H <(zcat $in) | grep '@HD' | pigz -p $threads -f > $out
    samtools view -H <(zcat $in) | grep '@SQ' | sort -t$'\t' -k1,1 -k2,2V | pigz -p $threads -f >> $out
    samtools view -H <(zcat $in) | grep '@RG' | pigz -p $threads -f >> $out
    samtools view -H <(zcat $in) | grep '@PG' | pigz -p $threads -f >> $out
else
    samtools view -H <(cat $in)|grep '@HD' | pigz -p $threads -f > $out
    samtools view -H <(cat $in)|grep '@SQ' | sort -t$'\t' -k1,1 -k2,2V |pigz -p $threads -f >> $out
    samtools view -H <(cat $in)|grep '@RG' | pigz -p $threads -f >> $out
    samtools view -H <(cat $in)|grep '@PG' | pigz -p $threads -f >> $out
fi

if [[ "$1" == *bwa* ]] || [[ -n "$bwa" ]]
then
    if [[ "$1" == *.gz* ]]
    then
        zcat $in | grep -v "^@"| grep -v -e $'\t''XA:Z:' -e $'\t''SA:Z:' | pigz -p $threads -f >> $out
    else
        cat $in | grep -v "^@"| grep -v -e $'\t''XA:Z:' -e $'\t''SA:Z:' | pigz -p $threads -f >> $out
    fi
else
    if [[ "$1" == *.gz* ]]
    then
        zcat $in | grep -v "^@" | grep -w -P "NH:i:1|tp:A:P" | pigz -p $threads -f >> $out
    else
        cat $in | grep -v "^@" | grep -w -P "NH:i:1|tp:A:P" | pigz -p $threads -f >> $out
    fi
fi

#RNAplex interactions cluster submitter
#!/bin/bash
#arguments $1 = path_fasta_directory, $2 = path_accessibility_directory $3 = path_output_directory
#Example call:
#qsub -t 1-2 ~egg/current/RNAnet/scripts/bulk_qsub_self_rnaplex.sh /scr/k70san/fall/RINTERwahn/PARIS/Annotated/Beds/SplitFasta/ /scr/k70san/fall/RINTERwahn/PARIS/Annotated/Beds/PlFold_Indexed/ /scr/k70san/fall/RINTERwahn/PARIS/PlexOut/

#$ -j yes
#$ -o /scr/k70san/fall/RINTERwahn/PARIS/PlexOut/RINTERwahn.out
#$ -e /scr/k70san/fall/RINTERwahn/PARIS/PlexOut/RINTERwahn.out
##$ -q hostname="xc00|xc01|xc02|xc03|xc05|xc06|xc07|xc08|tc00|tc01|tc03|tc02|tc04"
#$ -q short.q
#$ -N Muhhh
#BE CAREFUL ONLY ONE LINE FASTA
#iabulk_rnaplex args: path_fasta_directory fst_fasta_index snd_fasta_index path_accessibility_directory path_output_directory
/scr/k70san/fall/RINTERwahn/ia_bulk_rnaplex.sh $SGE_TASK_ID $SGE_TASK_ID $1 $2 $3

#!/usr/bin/env bash

in=$1
out=$2

if [ ! -f $out ]; then
	echo -ne "SAMPLE\tCCACCA\tCCACC\tCCAC\tCCA\tCC\tCA\tC\tA" > $out
fi

fn=${in#*/}

echo -ne "\n$fn\t" >> $out
#perl -se '{$o = (split("\/",$f))[-1];print "\n".$o."\t"}' -- -f=$in >> $out

for a in CCACCA CCACC CCAC CCA CC CA C A;do
	zgrep -w $a $in | perl -sae 'BEGIN{$c=0}{if($F[1] eq "seq"){$c+=$F[3]}}END{if($e ne "A"){print $c."\t"}else{print $c}}' -- -e=$a >> $out
done

#awk -v e="$a" 'BEGIN{FS="\t";OFS="";c=0}{c+=$3}END{if(e != "A"){print c,"\t"}else{print c}}' >> $out

#!/bin/bash

in=$1
out=$2
threads=$3
specialmappers="${4:-}"

samtools view -H ${in} | grep '@HD' > ${in}_head
samtools view -H ${in} | grep '@SQ' | sort -t$'\t' -k1,1 -k2,2V >> ${in}_head
samtools view -H ${in} | grep '@RG' >> ${in}_head
samtools view -H ${in} | grep '@PG' >> ${in}_head


if [[ "$1" == *bwa* ]] || [[ "$specialmappers" == *bwa* ]]
then
    cat ${in}_head <(samtools view --threads ${threads} -F 4 ${in} | grep -v "^@"| grep -v -e $'\t''XA:Z:' -e $'\t''SA:Z:') | samtools view --threads ${threads} -hb - > ${out}
elif [[ "$1" == *minimap* ]] || [[ "$specialmappers" == *minimap* ]]
then
    cat ${in}_head <(samtools view --threads ${threads} -F 4 ${in} | grep -v "^@" | perl -wlane 'print if $F[4] >=60') | samtools view --threads ${threads} -hb - > ${out}
else
    cat ${in}_head <(samtools view --threads ${threads} -F 4 ${in} | grep -v "^@" | grep -w -P "NH:i:1|tp:A:P") | samtools view --threads ${threads} -hb - > ${out}
fi

rm -f ${in}_head

#!/usr/bin/env bash

in=$1
out=$2

if [ ! -f $out ]; then
	echo -ne "SAMPLE\tCCA" > $out
fi

fn=${in#*/}

echo -ne "\n$fn\t" >> $out

for a in CCA;do
	zcat $in|perl -sae 'BEGIN{$c=0}{if($F[0] eq $e){$c+=$F[1]}}END{{print $c}}' -- -e=$a >> $out
done

#zcat $fn|perl -sae 'print $fn."\t".join("\t",@F)' -- -e=$fn >> $out
#echo -ne "\n" >> $out

#!/bin/bash

in=$1
out=$2
threads=$3
bwa="${4:-}"

samtools view -H ${in} | grep '@HD' > nhead
samtools view -H ${in} | grep '@SQ' | sort -t$'\t' -k1,1 -k2,2V >> nhead
samtools view -H ${in} | grep '@RG' >> nhead
samtools view -H ${in} | grep '@PG' >> nhead


if [[ "${in}" == *bwa* ]] || [[ -n "${bwa}" ]]
then
    cat nhead <(samtools view --threads ${threads} -F 4 ${in} | grep -v "^@"| grep -e $'\t''XA:Z:' -e $'\t''SA:Z:') | samtools view --threads ${threads} -hb - > ${out}
else
    cat nhead <(samtools view --threads ${threads} -F 4 ${in} | grep -v "^@" | grep -v -w -P "NH:i:0|NH:i:1|tp:A:P") | samtools view --threads ${threads} -hb - > ${out}
fi

rm -f nhead

---
title: "MONSDA SUMMARY REPORT"
date: "`r Sys.Date()`"
author: "`r Sys.getenv('LOGNAME')`"
output:
  rmdformats::readthedown:
    code_folding: show
    self_contained: false
    thumbnails: false
    lightbox: false
pkgdown:
  as_is: true
params:
  root: ''
  outdir: ''
---


```{r setup, include=FALSE}
library(knitr)
knitr::opts_chunk$set(echo = TRUE)
knitr::opts_knit$set(root.dir = params$root)
```
